\ ANSFILE.F

\ This is an ANSI file words set
\ ansfile.f
\
\ The words defined in this file follow the draft proposed AMERICAN
\ NATIONAL  Standard for Information System - Programing Language - Forth
\ - June 30, 1993
\
\ If ior = 0, operation is O.K.; Otherwse, it is a failure.

cr .( Loading ANSI File Wordset...)

only forth also definitions


                     : bin ;                   \ BIN
GENERIC_READ  constant r/o                     \ GENERIC_READ
GENERIC_WRITE constant w/o                     \ GENERIC_WRITE
r/o w/o +     constant r/w                     \ READ/WRITE
256           constant max-handle

variable _hdl-search
         _hdl-search off

0 value #files                  \ number of files found
0 value total-file-bytes        \ total bytes in files found


create z-buf  MAXSTRING allot
create z-buff MAXSTRING allot

create _win32-find-data                 \ struct FindFileFirst or
                                        \ FindNextFile Functions
   0 ,                                  \ dwFile Attributees
   0 , 0 ,                              \ ftCreationTime - FILETIME -
                                        \ (struct) dwLowDateTime
                                        \          dwHighDateTime
   0 , 0 ,                              \ ftLastAccessTime - FILETIME
   0 , 0 ,                              \ ftLastWriteTime - FILETIME
   0 ,                                  \ nFileSizeHigh
   0 ,                                  \ nFileSizeLowh
   0 ,                                  \ dwReserved0
   0 ,                                  \ dwReserved1
   MAX-PATH allot                       \ cFileName[MAX_PATH]
   14 allot                             \ cAlternateFileNane[14]

create ptr-DOS-date 0 w,                \ ptr to 16 bit DOS date
create ptr-DOS-time 0 w,                \ ptr to 16 bit DOS time

create _systemtime                      \ struct FileTimeToSystemTime
                                        \ function; this struc is same
                                        \ as time-buf in kernel.tom
        0 w,                            \ +0  wYear
        0 w,                            \ +2  wMonth
        0 w,                            \ +4  wDayOfWeek
        0 w,                            \ +6  wDayOfMonth
        0 w,                            \ +8  wHour
        0 w,                            \ +10 wMinute
        0 w,                            \ +12 wSecond
        0 w,                            \ +14 wMilliseconds



: asciiz ( adr slen -- asciiz-string )
   max-handle 1- min                         \ max slen of the string, 255
   0 over z-buff + c!                        \ adr 0 (slen+z-buff>
   z-buff swap move
   z-buff ;

: asciiz-b ( adr slen badr -- asciiz-string )
  \ This word is created to use in the word like rename-file that asciiz
  \ is used twice in the same word but can not share the same buff, z-buff
   >r max-handle 1- min                      \ max slen of the string, 255
   0 over r@ + c!                            \ adr 0 (slen+z-buff>
   r@ swap move
   r> ;

: open-file ( adr slen fmode -- fileid ior )
   -rot asciiz                               \ fmode adrstr -
   >r >r                                     \ ( r: adrstr fmode  )
   0                                         \ hTemplateFile
   0                                         \ fdwAttrsAndFlag
   OPEN_EXISTING                             \ fdwCreate
   0                                         \ lpsa
   FILE_SHARE_READ
   r@ r/o <>                                 \ NOT read only, share writing
   if   FILE_SHARE_WRITE or                  \ fdwShareMode
   then
   r>                                        \ fdwAcess(fmode)
   r> rel>abs                                \ lpszName(adr)
   call CreateFile
   dup INVALID_HANDLE_VALUE = ;              \ fileid ior = 0 = success

: close-file ( fileid -- ior )
   call CloseHandle 0= ;                     \ hObject
                                             \ 0 = success

: read-file     ( b-adr b-len fileid -- len ior )
                { b-adr b-len fileid \ len-read -- len ior }
   0                                         \ lpOverlapped
   &LOCAL len-read rel>abs                   \ lpNumberOfBytesRead
   b-len                                     \ nNumberOfByteToRead(b-len)
   b-adr rel>abs                             \ lpBuffer(b-adr)
   fileid                                    \ hFile
   call ReadFile
   len-read swap 0= ;                        \ len ior = 0 = success

: write-file    ( adr slen fileid -- ior )
                { adr slen fileid \ len-written -- ior }
   0                                         \ lpOverlapped
   &LOCAL len-written rel>abs                \ lpNumberOfBytesWritten
   slen                                      \ nNumberOfBytesToWrite(slen)
   adr rel>abs                               \ *lpBuffer(adr)
   fileid                                    \ hFile
   call WriteFile
   0= ;                                      \ ior = 0 = success

: create-file ( adr slen fmode -- fileid ior )
   -rot asciiz >r >r                         \ fmode adr -
   0                                         \ hTemplateFile
   0                                         \ fdwAttrsAndFlag
   CREATE_ALWAYS                             \ fdwCreate
   0                                         \ lpsa
   0                                         \ fdwShareMode
   r>                                        \ fdwAcess(fmode)
   r> rel>abs                                \ lpszName
   call CreateFile
   dup INVALID_HANDLE_VALUE = ;              \ fileid ior - 0 = success

: delete-file ( adr len -- ior )
   asciiz rel>abs                            \ lpszFileName
   call DeleteFile 0= ;                      \ ior - 0 = success

: rename-file ( adr1 len adr2 len -- ior )
   z-buf  asciiz-b rel>abs >r                \ adr1a - use z-buf
   z-buff asciiz-b rel>abs                   \ adr2a - use z-buff
   r> swap                                   \ adr1a adr2a -
                                             \ lpszEisiting(adr1a)
                                             \ lpszNew(adr2a)
   call MoveFile 0= ;                        \ ior - 0 = success


: file-position ( fileid -- len-ud ior )
                { fileid \ file-poshi -- len-ud ior }
   FILE_CURRENT                                 \ dwMoveMethod
   &LOCAL file-poshi OFF
   &LOCAL file-poshi rel>abs                    \ lpDistanceToMoveHigh
   0                                            \ lDistanceToMove
   fileid                                       \ hFile
   call SetFilePointer file-poshi 0 ;           \ len-ud ior - 0 = success

: reposition-file ( len-ud fileid -- ior )
                  { len-lo len-hi fileid -- ior }
   FILE_BEGIN                                \ dwMoveMethod
   &LOCAL len-hi rel>abs                     \ lpDistanaceToMoveHigh
   len-lo                                    \ lDistanceToMove
   fileid                                    \ hFile
   call SetFilePointer drop 0 ;              \ ior - 0 = success

: file-size     ( fileid -- len-ud ior )
                { fileid \ size-poshi -- len-ud ior }
   fileid file-position drop                    \ len-ud -
   FILE_END                                     \ dwMoveMode
   &LOCAL size-poshi OFF
   &LOCAL size-poshi rel>abs                    \ lpDistanceToMoveHigh
   0                                            \ lDistanceToMove
   fileid                                       \ hFile
   call SetFilePointer size-poshi               \ new len-ud
   2swap fileid reposition-file drop            \ use old len-ud to
                                                \  reposition file pointer
   0                                            \  back to the old position
   ;                                            \ ior - 0 = success

: file-append   ( fileid -- ior )
                { fileid \ size-poshi -- ior }
   FILE_END                                     \ dwMoveMode
   &LOCAL size-poshi OFF
   &LOCAL size-poshi rel>abs                    \ lpDistanceToMoveHigh
   0                                            \ lDistanceToMove
   fileid                                       \ hFile
   call SetFilePointer drop 0 ;                 \ ior - 0 = success

: flush-file ( fileid -- ior )
   call FlushFileBuffers 0= ;                   \ ior - 0 = success

0 value _read-line-len
0 value not-end?

: read-line     ( adr len fileid -- len eof ior )
                >r                              \ save the fileid
                0max dup to _read-line-len
                1+ 2dup r@ read-file ?dup       \ read requested chars+1
                if      r>drop
                        >r drop 2drop 0 -1 r>   \ ior <> 0 = error
                        EXIT
                then    2dup = to not-end?
                        min dup                 \ if read ANY characters
                if      _read-line-len min to _read-line-len
                        _read-line-len 0x0D scan dup  \ look for CR
                        if      _read-line-len over - to _read-line-len
                                1 /string       \ remove it
                        then
                        over c@ 0x0A =          \ then look for LF
                        over 0= and 0=          \ not split crlf
                   if   1 /string               \ and remove LF
                        nip                     \ -- length_remaining
                        r@ file-position 2drop  \ -- remainder current_filepos
                        swap -                  \ actual position+1
                        not-end?                \ only if we read what we
                        if      1- 0max         \ backup one to correct
                        then    0               \ new current ud
                        r@ reposition-file drop
                   else 2drop
                   then r>drop
                        _read-line-len -1 0
                else    2drop
                        r>drop          \ discard fileid
                        0 0 0           \ return 0=len, eof=false ior=false
                then    ;

: write-line    ( adr len fileid -- ior )
                          dup>r write-file
                crlf$ count r>  write-file or ; \ ior - 0 = success

: resize-file   ( len-ud fileid -- ior )
                dup>r reposition-file drop
                r> call SetEndOfFile 0= ;    \ ior - 0 = success

: file-status   ( adr len -- x ior )
                r/o open-file dup 0=
                if      swap close-file drop
                else    nip
                then    0 swap ;         \ ior - 0 = success

\ Get a drives free space, cluster and sector information
\ "zroot" is the root directory spec zString for the desired drive in the
\ format z" x:\", where x can be a, b, c, d or e etc...
: get-fspace { zroot \ clus freclus b/sec s/clus -- as bs cs ds }
        &LOCAL clus     rel>abs                 \ lpClusters - bs
        &LOCAL freclus  rel>abs                 \ lpFreeClusters - as
        &LOCAL b/sec    rel>abs                 \ loBytesPerSector - ds
        &LOCAL s/clus   rel>abs                 \ lpSectorsPerCluster - cs
        zroot           rel>abs                 \ lpszRootPathName
        call GetDiskFreeSpace
        if      freclus  clus                   \ as bs -
                s/clus  b/sec                   \ as bs cs ds -
        else    0 0 0 0                         \ 0 0 0 0 - for failure
        then    ;

: find-first-file ( adr slen -- adrd ior )
  \ name(adr) - null-terminated valid directory or path and filename
  \ len - length of ascii name in bytes
  \ adrd - address of _win32-find-data struc
   asciiz rel>abs                            \ adrz -
   _win32-find-data rel>abs                  \ lpffd - _WIN32_FIND_DATA
   swap                                      \ lpszSourceFile
   call FindFirstFile                        \ a search handle(hdl if O.K.
                                             \ else INVALID_HANDLE_VALUE)
   _hdl-search !                             \ store to the search handle
   _win32-find-data                          \ adrd -
   _hdl-search @ -1 = ;                      \ adrd ior - 0 = success


: find-next-file ( -- adrd ior ) \ find-first-file word must be called
  \ before this word can be called due to that _hdl-search is needed
   _win32-find-data rel>abs                  \ lpffd - _WIN32_FIND_DATA
   _hdl-search @                             \ hFindFile
   call FindNextFile                         \ ior -
   _win32-find-data                          \ ior adrd -
   swap 0= ;                                 \ adrd ior - 0 = success

: find-close ( -- ior ) \ close the _hdl-search handle
   _hdl-search @
   call FindClose 0= ;                       \ ior - 0 = success

\ : file-info     ( fileid -- adrd ior )
\   \ get windows information on the currently open file
\    _win32-find-data rel>abs swap
\    call GetFileInformationByHandle
\    _win32-find-data swap 0= ;

\ : .file-info    ( fileid -- )   \ display information about the current file
\         file-info abort" Failed to get information about the file"
\         cr ." Attributes: "    dup @ h.
\         drop ;


: get-DOS-create-datetime ( -- ;convert 64 bit file time to MS_DOS )
\ date and time values
   \ need to call directory-fine-first or directory-fine-next word
   \ before usning this word
   ptr-DOS-time rel>abs ptr-DOS-date rel>abs \ ptr's to 16 bit DOS
                                        \ time & date
   _win32-find-data rel>abs 1 cells+
   call FileTimeToDosDateTime drop ;

: get-DOS-access-datetime ( -- ;convert 64 bit file time to MS_DOS )
\ date and time values
   \ need to call directory-fine-first or directory-fine-next word
   \ before usning this word
   ptr-DOS-time rel>abs ptr-DOS-date rel>abs \ ptr's to 16 bit DOS
                                        \ time & date
   _win32-find-data rel>abs 3 cells+
   call FileTimeToDosDateTime drop ;

: get-DOS-write-datetime ( -- ;convert 64 bit file time to MS_DOS )
\ date and time values
   \ need to call directory-fine-first or directory-fine-next word
   \ before usning this word
   ptr-DOS-time rel>abs ptr-DOS-date rel>abs \ ptr's to 16 bit DOS
                                          \ time & date
   _win32-find-data rel>abs 5 cells+
   call FileTimeToDosDateTime drop ;

: get-file-size ( -- size )
   \ need to call directory-fine-first or directory-fine-next word
   \ before usning this word
   _win32-find-data 8 cells+ @ ;

: get-file-name ( -- adr; address for file name )
   \ need to call directory-fine-first or directory-fine-next word
   \ before usning this word
   _win32-find-data 11 cells+ ;

create file-time-buf 2 cells allot

: get-file-modified ( fileid -- system-time )
        >r
        file-time-buf 2 cells erase     \ pre-clear buffer
        file-time-buf rel>abs           \ address of where to put the file's
                                        \ last written time and date
        0                               \ last access time not needed
        0                               \ creation time not needed
        r> call GetFileTime drop

        _systemtime     rel>abs         \ where to put results
        file-time-buf   rel>abs         \ file time/date to convert
        call FileTimeToSystemTime drop
        _systemtime ;

: filetime-to-systemtime ( cell# -- ; convert file time to system time )
   \ need to call directory-fine-first or directory-fine-next word
   \ before usning this word
   \ cell# is offset in number of cells to _win32-find-data
   \ 1 for creation time; 3 for access time; and 5 for write time
   \ normall 5 should be used
   >r                                           \ cell# -> rstack
   _systemtime rel>abs                          \ struct FileTimeToSystemTime
                                                \ function
   _win32-find-data rel>abs r> cells+           \ struct FILETIME for
                                                \ ftWriteTime
   call FileTimeToSystemTime drop ;

: asciiz->asc-len ( adrz -- sadr slen )
        MAX-PATH 2dup 0                         \ adrz scan-len scan-let -
        scan                                    \ adr0 len-rem -
        nip - ;                                 \ slen -

: .dir->file-name ( -- ;print file name in the dir )
        _win32-find-data 11 cells+              \ adrz
        asciiz->asc-len                         \ adrz scan-len slen
        dup>r type                              \ adrz len  ;print file name
        12 r> - 0max spaces ;


: .dir->file-size ( -- ;print file size )
                _win32-find-data @ FILE_ATTRIBUTE_DIRECTORY and
                if   >bold   ."          dir " >norm
                else _win32-find-data 8 cells+ @ dup 12 u,.r space \ print nFileSizeLow
                     +to total-file-bytes
                then ;

: _print-dir-files ( adr slen -- )
                0 to total-file-bytes
                0 to #files                          \ reset # of files in dir
                find-first-file nip                  \ adrd ior - find first file
                0 <> if exit then                    \ if file is not found, exit
                cr .dir->file-size                   \ print the size of file
                   .dir->file-name                   \ print the filename found
                1 +to #files                         \ update file number
                BEGIN find-next-file nip 0=          \ ior - find next file
                WHILE   1 +to #files                   \ update file number
                        25 ?cr
                        .dir->file-size                \ print the size of file
                        .dir->file-name                \ and the name of file
                        start/stop
                REPEAT ;

: print-dir-files ( adr slen -- )
                cr >bold ." Directory of: " 2dup type >norm
                ['] _print-dir-files catch
                IF      2drop                   \ discard abort results
                THEN
                find-close drop
                cr >bold #files . ." Files displayed, using "
                total-file-bytes 1 u,.r ."  bytes of disk." >norm ;

: dir           ( -<name>- )    \ name = f.e where f or e can be ascii's, * , or ?
                /parse-word dup c@ 0=                    \ if not spec given, use *.*
                IF   s" *.*" pocket place
                THEN dup count + 1- c@ ':' =         \ if just a drive, add \
                IF   s" \"   pocket +place
                THEN dup count + 1- c@ '\' =         \ if it ends in a \, add *.*
                IF   s" *.*" pocket +place
                THEN count print-dir-files ;

: do-rename-afile { RenamePart1$ RenamePart2$ \ RenameTemp$ -- } \ rename one file
                MAXSTRING LocalAlloc: RenameTemp$
                _win32-find-data 11 CELLS+                      \ adrz
                asciiz->asc-len                                 \ adrz -- adr len
                2dup 2dup RenamePart1$ count caps-search
                IF      2dup 2>r nip -              RenameTemp$  place \ leading part
                        RenamePart2$ count          RenameTemp$ +place
                        2r> RenamePart1$ c@ /string RenameTemp$ +place
                        RenameTemp$ count rename-file ( adr1 len adr2 len -- ior=0=OK )
                        0=
                        IF      1 +to #files                    \ update file number
                        THEN
                ELSE    2drop 2drop 2drop
                THEN    ;

: rename        ( -<name1 part1 part2>- )     \ rename file or files
                { \ RenameFrom$ RenamePart1$ RenamePart2$ -- }
                MAXSTRING LocalAlloc: RenameFrom$
                MAXSTRING LocalAlloc: RenamePart1$
                MAXSTRING LocalAlloc: RenamePart2$
                /parse-word count RenameFrom$  place
                /parse-word count RenamePart1$ place
                /parse-word count RenamePart2$ place
                RenameFrom$  c@ 0>
                RenamePart1$ c@ 0> and
                RenamePart2$ c@ 0> and 0=
                IF      beep
                        cr ." Usage:"
                        cr ."    RENAME <filespec> <oldsubstring> <newsubstring>"
                        EXIT                    \ leave if no names specified
                THEN        
                cr >bold ." Rename Files: "
                RenameFrom$  count type ."  from: "
                RenamePart1$ count type ."  To: "
                RenamePart2$ count type >norm
                0 to #files                                     \ reset # of files in dir
                RenameFrom$ count find-first-file nip 0=        \ adrd ior - find first file
                IF      RenamePart1$
                        RenamePart2$
                        do-rename-afile
                        BEGIN   find-next-file nip 0=           \ ior - find next file
                        WHILE   RenamePart1$
                                RenamePart2$
                                do-rename-afile
                        REPEAT find-close drop
                        cr >bold #files . ." Files renamed" >norm
                ELSE    cr ." No matching files Found"          \ if file is not found, exit
                THEN    ;


