\ CALLBACK.F    Windows Callback support                by Tom Zimmer

\ December 19th, 1996 tjz this file must follow the loading of WINLIB.F.

\ 960827 bee ??? SP0 in code

cr .( Loading Windows Callback...)

\ This version doesn't require an assembler, it is hard coded

                \ n1=number of callback arguments
                \ a1=callback address
                \ a2=address of where to put the cfa of the called back function

: BUILD-CALLBACK ( n1 -- a1 a2 )        \ define a callback procedure
                >r                      \ save number of arguments
                [ forth ]
                        here    here cell+ ,            \ callreturn:
                                here cell+ ,
\ cr ." First instruction of callback assembled at: " here .

0xC38B W, \     [ assembler ]   mov     eax, ebx
0xE58B W, \                     mov     esp, ebp
0x428F W, SP0 FOLLOWER - C,  \  pop     SP0 [UP]
0x5D C, \                       pop     ebp
0x5B C, \                       pop     ebx
0x5F C, \                       pop     edi
0x5E C, \                       pop     esi         a;
0xC2 C, R@ CELLS W, \           ret     # R@ CELLS  a;  \ return deleting arguments
                        HERE
0x58 C, \                       pop     eax             \ callforth:, thunk address
0x56 C, \                       push    esi
0x57 C, \                       push    edi
0x53 C, \                       push    ebx
0x55 C, \                       push    ebp
0xF88B W, \                     mov     edi, eax        \ thunk address
0x478B W, 4 C, \                mov     eax, 4 [edi]    \ cfa of word to execute
0x3F2B W, \                     sub     edi, 0 [edi]    \ edi now has forth base address
0x978D W, CONUSER FOLLOWER RP0 - + , \ lea  edx, CONUSER FOLLOWER RP0 - + [edi] \ init user pointer
0x72FF W, SP0 FOLLOWER - C,  \  push    SP0 [UP]        \ save top of stack pointer
0xEC8B W, \                     mov     ebp, esp
0xEC81 W, 0x0FA0 , \            sub     esp, # 0x0FA0   \ 4000 byte return stack
0x6289 W, SP0 FOLLOWER - C,  \  mov     SP0 [UP], esp
0x7A29 W, SP0 FOLLOWER - C,  \  sub     SP0 [UP], edi  a;
                [ forth ]       r@ 1 >
                                if      r@ 1- 0
                                        do
0x75FF W, \     [ assembler ]   push    i cells 6 CELLS+ [ebp] a;
I CELLS 6 CELLS+ C, \
                [ forth ]               loop
                                then
                                r@
                                if
0x5D8B W, \     [ assembler ]   mov     ebx, r@ 1- cells 6 CELLS+ [ebp] a;
R@ 1- CELLS 6 CELLS+ C, \
                [ forth ]       then    r>drop
                                >r >r
0xB78D W, R> , \                lea     esi, r> ( xxx ) [edi] a;        \ callreturn:
0x8B C, 0x380C W, \             mov     ecx, 0 [eax] [edi]
0xCF03 W, \                     add     ecx, edi
0xE1FF W, \                     jmp     ecx     a;
                [ forth ]       here                            \ a1=THE CALLBACK ADDRESS
0x90 C, \       [ assembler ]   nop
0x90 C, \                       nop
0x90 C, \                       nop
0xE8 C, R> HERE 4 + - , \       call    r> ( yyy ) a;                   \ callforth:
                [ forth ]       here , here 0 , ;

: callback      ( n1 -<name function>- )        \ define a callback with "name" that has n1 arguments
                ( -- a1 )                       \ runtime, returns address of callback
                build-callback >r constant ' r> ! ;

: CallBack:     { #args \ addr temp$ -<name>- } \ makes a headerless callback function, only
                ( -- a1 )                       \ the callback structure has a header
                #args build-callback to addr
                64 localAlloc: temp$            \ use a dynamic string buffer
                s" constant &"      temp$  place
                >in @ bl word count temp$ +place
                >in !                           \ get a copy of next word in input stream
                temp$ count evaluate            \ make a constant starting with '&'
                :                               \ build the colon definitions starting structure
                here body> addr ! ;             \ patch callback structure

\ *************************************************************************
\ ***************** An example of how to use a callback *******************
\ *************************************************************************

\ The "EnumFonts" windows call requires an application callback that will be
\ called repeatedly to process each font in the system. We are just
\ displaying the fonts, so we just look at the "dwType" to decide how to
\ display each font.

\ NOTE!: CallBack: creates TWO definitions!  The first has the name you specify,
\       and the second has the same name, prefixed with a '&' meaning 'address of'
\       This second definition is the one which returns the address of the
\       callback, and must be passed to Windows.

4 CallBack: FontFunc { lplf lptm dwType lpData -- int }
                cr                                      \ rls - many additions
                dwType
                dup TRUETYPE_FONTTYPE and
                IF      ."     "
                ELSE    ." Non-"
                THEN    ." TrueType "
                dup RASTER_FONTTYPE and
                IF      ." Raster "
                ELSE    ." Vector "
                THEN
                DEVICE_FONTTYPE and
                IF      ." Device "
                ELSE    ." GDI    "
                THEN
                lplf abs>rel 28 + LF_FACESIZE 2dup 0 scan nip - type
                cr 5 spaces
                lplf abs>rel dup @ 4 .r         \ height
                4 + dup @ 4 .r                  \ width
                4 + dup @ 6 .r.1                \ escapement angle
                4 + dup @ 6 .r.1                \ orientation angle
                4 + dup @ 4 .r                  \ weight
                4 + dup c@ 1 and 2 .r           \ italics
                1 + dup c@ 1 and 2 .r           \ underline
                1 + dup c@ 1 and 2 .r           \ strike-out
                1 + dup c@ 4 .r                 \ character set
                1 + dup c@ 2 .r                 \ output precision
                1 + dup c@ 4 .r                 \ clip precision
                1 + dup c@ 2 .r                 \ output quality
                1 +     c@ 4 h.r                \ family and pitch
                1 ;             \ return "1=success" flag to windows

\ this callback as specified by "EnumFonts" passes four (4) parameters to
\ the callback procedure, so we must say "4 CallBack: FontFunc" to define
\ a callback that accepts four parameters.

\ the callback name is passed to windows as shown, after converting the
\ callback address to an absolute address for windows.

: .fonts        ( -- )
                cr 5 spaces
                ."   ht wide  esc  ornt wt  I U S set p  cp q  fp"
                0
                &FontFunc rel>abs
                0
                conDC                   \ the Device Context of the DC
                Call EnumFonts drop ;

\ *************************************************************************
\ **************** allow Forth to handle windows messages *****************
\ *************************************************************************
-1 value WM_WIN32FORTH

: HandleMessages { pMsg -- 0 }
                pMsg TRUE msg-chain do-chain nip
                if      pMsg Call TranslateMessage drop
                        pMsg Call DispatchMessage  drop
                then    0 ;

1 callback &HandleMessages HandleMessages  \ create the callback for DoForthFunc

: HandleWindowsMessages { hwnd msg wParam lParam -- flag }
                msg WM_WIN32FORTH =
                if      hwnd msg wParam lParam
                        forth-msg-chain do-chain        \ perform the handlers
                        4drop
                        0
                else    hwnd msg wParam lParam
                        DefaultWindowProc               \ use default handler
                then    ;

4 callback &WindowsMessages HandleWindowsMessages

: HandleMessages-init ( -- )
                &HandleMessages  rel>abs &message-callback !
                &WindowsMessages rel>abs &winmessage-callback !
                ;

HandleMessages-init

initialization-chain chain-add HandleMessages-init

\  *************************************************************************
\S *********************** PURE ASSEMBLER VERSION **************************
\  *************************************************************************

\ Assembler required

                \ n1=number of callback arguments
                \ a1=callback address
                \ a2=address of where to put the cfa of the called back function

: BUILD-CALLBACK ( n1 -- a1 a2 )        \ define a callback procedure
                >r                      \ save number of arguments
[ forth ]
        here    here cell+ ,            \ callreturn:
                here cell+ ,
[ assembler ]   mov     eax, ebx
                mov     esp, ebp
                pop     SP0 [UP]        \ recover top of stack pointer
                pop     ebp
                pop     ebx
                pop     edi
                pop     esi
                ret     # r@ cells   a; \ return deleting arguments
        here    pop     eax             \ callforth:, thunk address
                push    esi
                push    edi
                push    ebx
                push    ebp
                mov     edi, eax        \ thunk address
                mov     eax, 4 [edi]    \ cfa of word to execute
                sub     edi, 0 [edi]    \ edi now has forth base address
                                        \ init user pointer
                lea     edx, CONUSER FOLLOWER RP0 - + [edi]
                push    SP0 [UP]        \ save stack top ptr
                mov     ebp, esp
                sub     esp, # 0xFA0    \ 4000 byte return stack
                mov     SP0 [UP], esp
                sub     SP0 [UP], edi  a;
[ forth ]       r@ 1 >
                if      r@ 1- 0
                        do              \ 6 = number of arguments plus one
[ assembler ]                   push    i  cells 6 CELLS+ [ebp] a;
[ forth ]               loop
                then
                r@
                if
[ assembler ]           mov     ebx, r@ 1- cells 6 CELLS+ [ebp] a;
[ forth ]       then    r>drop
                >r >r
[ assembler ]   a;
                lea     esi, r> ( xxx ) [edi] a;        \ callreturn:
                mov     ecx, 0 [eax] [edi]
                add     ecx, edi
                jmp     ecx     a;
[ forth ]       here                                    \ a1=the callback address
[ assembler ]   nop
                nop
                nop
                call    r> ( yyy ) a;                   \ callforth:
[ forth ]       here , here 0 , ;

: callback      ( n1 'name' 'function' -- )     \ define a callback with "name" that has n1 arguments
                build-callback >r constant ' r> ! ;

: CallBack:     { #args \ addr temp$ -<name>- } \ makes a headerless callback function, only
                ( -- a1 )                       \ the callback structure has a header
                #args build-callback to addr
                64 localAlloc: temp$            \ use a dynamic string buffer
                s" constant &"      temp$  place
                >in @ bl word count temp$ +place
                >in !                           \ get a copy of next word in input stream
                temp$ count evaluate            \ make a constant starting with '&'
                :                               \ build the colon definitions starting structure
                here body> addr ! ;             \ patch callback structure

