\ $Id: dc.fth 1.2 1994/03/22 14:57:01 andrew Exp $

cr .( Loading Device Context and Printing...)

\ Encapsulates windows device context.

\  0 value last-good
\ 16 value max-parameters
\   create parameters-buf max-parameters 1+ cells allot
\          parameters-buf max-parameters 1+ cells erase
\
\ : win-parameters ( ?? n1 -- )    \ save away n1 parameters from stack
\                 ?win-error-enabled
\         if      parameters-buf cell+ @ to last-good
\                 parameters-buf !
\                 depth parameters-buf @ <
\                 if      false to ?win-error-enabled
\                         debug-io
\                         tabbing-off
\                         cr ." Not enough parameters for: "
\                         r@ abs>rel 2 cells - @ .name
\                         cr ." Needed: " r> . ." only got: " depth .
\                         cr
\                         .rstack
\                         restore-io
\                 else    parameters-buf @ max-parameters min 0
\                         ?do     i pick parameters-buf i 1+ cells+ !
\                         loop
\                 then
\         else    drop
\         then    ;
\
\
\ : ?win-error-dump ( f1 -- )
\                 0=
\                 ?win-error-enabled and
\                 if      false to ?win-error-enabled
\                         debug-io
\                         tabbing-off
\                         cr ." On Function: "
\                         r@ abs>rel 2 cells - @ .name
\                         cr ." Last good handle: " last-good h.
\                         cr ." With " parameters-buf @ . ." Parameters: "
\                         cr parameters-buf @ max-parameters min 1+ 1
\                         ?do     parameters-buf i cells+ @ h.
\                         loop    0 parameters-buf !
\                         cr ."  Windows Returned Error:"
\                         call GetLastError . cr
\                         .Rect: TempRect
\                         cr .s
\                         .rstack
\                         restore-io
\                 then    ;

: NewStruct     ( n1 --- hstruct )
                dup>r malloc dup r> erase ;

: DeleteStruct  ( hstruct -- )
                release ;

  8 value CHAR-WIDTH            \ Width of each character in pixels
 14 value CHAR-HEIGHT           \ Height of each character in pixels

:CLASS WinDC   <Super Object


int hdc         \ Handle to the device context
int tabbuf
int tabcnt
int tabwidth
int currentfont

Rectangle FillRect

40 constant deftabs

deftabs cells bytes tabarray

:M DefaultTabs: ( -- )
                deftabs 0
                ?do     i 1+ tabwidth * char-width *
                        tabarray i cells+ !     \ fill default tabs
                loop
                tabarray to tabbuf
                deftabs  to tabcnt
                ;M

:M ClassInit:   ( -- )
                ClassInit: super
                8 to tabwidth
                DefaultTabs: self
                0        to hdc
                ;M

:M SetTabs:     ( a1 n1 -- )    \ a1 is array of cells with offsets
                to tabcnt
                to tabbuf
                ;M

:M SetTabSize:  ( n1 -- )
                to tabwidth
                DefaultTabs: self
                ;M

:M GetTabSize:  ( -- n1 )
                tabwidth
                ;M

:M GetHandle:   ( -- hdc )  hdc  ;M

:M PutHandle:   ( hdc -- )  to hdc  ;M

:M SelectObject:  ( object -- oldobj )
                hDC Call SelectObject
                ;M

:M DeleteObject:  ( object -- )
                Call DeleteObject ?win-error
                ;M

:M GetStockObject: ( id -- object )
                Call GetStockObject
                ;M

:M SelectStockObject:  ( id -- oldobj )
                GetStockObject: self  SelectObject: self
                ;M

:M GetTextMetrics:  ( tm -- )
                rel>abs hDC Call GetTextMetrics ?win-error
                ;M

:M GetTextExtent:  { adr len \ exttemp -- width height }
                2 cells LocalAlloc: exttemp     \ allocate some space
                exttemp 2 cells erase           \ init it to zeros
                exttemp rel>abs
                len
                adr rel>abs
                Win32s?
                IF      hDC Call GetTextExtentPoint   ?win-error
                ELSE    hDC Call GetTextExtentPoint32 ?win-error
                THEN
                exttemp @                       \ the width
                exttemp cell+ @                 \ the height
                ;M

:M SetTextColor:  { color_object -- }
                color_object ?ColorCheck drop
                Color: color_object hdc Call SetTextColor drop
                ;M

:M SetBkColor:  { color_object -- }
                color_object ?ColorCheck drop
                Color: color_object hDC Call SetBkColor   drop
                ;M

:M SetBkMode:   ( mode  -- )
                hDC Call SetBkMode    drop
                ;M

:M SaveDC:      ( -- )  \ Save current DC context and objects including the
                        \ current font.
                hDC Call SaveDC drop
                ;M

:M RestoreDC:   ( -- )  \ restore current DC context including font
                -1 hDC Call RestoreDC ?win-error
                ;M

:M SetFont:     ( font_handle -- )
                dup to currentfont
                SelectObject: self drop
                ;M

:M GetFont:     ( -- font_handle )
                currentfont
                ;M

:M TextOut:     ( x y addr len -- )
                swap rel>abs 2swap swap hDC Call TextOut ?win-error
                ;M

:M DrawText:    ( addr len rect format -- )
                swap rel>abs 2swap swap rel>abs hDC Call DrawText drop
                ;M

:M TabbedTextOut: ( x y addr len -- text_dimensions )
                2>r 2>r 0 tabbuf rel>abs tabcnt 2r> 2r>
                swap rel>abs 2swap swap hDC Call TabbedTextOut
                ;M

:M LineColor:   { color_object -- }
                color_object ?ColorCheck drop
                Pen: color_object hDC Call SelectObject drop
                ;M

:M PenColor:    { color_object -- }
                color_object LineColor: self
                ;M

:M BrushColor:  { color_object -- }
                color_object ?ColorCheck drop
                Brush: color_object hDC Call SelectObject drop
                ;M

:M MoveTo:      ( x y -- )
                0 -rot swap
                hDC Call MoveToEx ?win-error
                ;M

:M LineTo:      ( x y -- )
                swap
                hDC Call LineTo ?win-error
                ;M

\ July 29th, 1998 - 9:03 tjz
\ Removed an extra swap after 'rel>abs' in the following two definitions,
\ per a bug reported by Pierre Abbat

:M PolyBezierTo: ( ptr cnt -- )         \ rls - new *** Note: NOT in Win32S!
                swap rel>abs hDC Call PolyBezierTo ?win-error ;M

:M PolyBezier:  ( ptr cnt -- )          \ rls - new *** Note: NOT in Win32S!
                swap rel>abs hDC Call PolyBezier   ?win-error ;M

\ July 29th, 1998 - 9:03 tjz
\ Added Polygon: as suggested by Pierre Abbat

:M Polygon:     ( ptr cnt - )           \ tjz - new *** Note: NOT in Win32S!
                swap rel>abs hDC Call Polygon ?win-error ;m

:M PolyDraw:    ( tptr pptr cnt -- )    \ rls - new *** Note: NOT in Win32S!
                rot rel>abs rot rel>abs rot
                hDC Call PolyDraw   ?win-error ;M

:M BeginPath:   ( -- )
                hDC Call BeginPath      ?win-error ;M

:M FillPath:    ( -- )
                hDC Call FillPath       ?win-error ;M

:M StrokePath:  ( -- )                 
                hDC Call StrokePath     ?win-error ;M

:M FillPath:    ( -- )                  \ rls - new  ? Needs Brushes ?
                hDC Call FillPath       ?win-error ;M

:M StrokeAndFillPath:    ( -- )         \ rls - new  ? Needs Brushes ?
                hDC Call StrokeAndFillPath      ?win-error ;M

:M EndPath:     ( -- )                
                hDC Call EndPath       ?win-error ;M

:M SetROP2:     ( mode -- oldmode )
                hDC Call SetROP2
                ;M

:M SetPixel:    { x y color_object -- }
                color_object ?ColorCheck drop
                Color: color_object y x hDC Call SetPixel drop
                ;M

:M GetPixel:    ( x y -- colorref )     \ returns a "COLORREF", not a color object
                swap
                hDC Call GetPixel
                ;M


:M BitBlt:      ( blitmode sourcex,y sourcedc sizex,y destinationx,y -- )
                2>r 2>r >r swap r> 2r> swap 2r> swap
                hdc ( 9 win-parameters ) call BitBlt ?win-error ;M

:M StretchBlt:  ( blitmode srcsizex,y srcx,y srcdc dstsizex,y dstx,y -- )
                2>r                             \ save dstx,y
                2>r                             \ save dstsizex,y
                >r                              \ save srcdc
                2>r                             \ save srcx,y
                swap                            \ swap srcsizex,y
                2r> swap                        \ recover, swap srcx,y
                r>                              \ recover srcdc
                2r> swap                        \ recover, swap dstsizex,y
                2r> swap                        \ recover, swap dstx,y
                hdc ( 11 win-parameters ) call StretchBlt ?win-error ;M

:M FillRect:    { color_object rectangle -- }
                color_object ?ColorCheck drop
                Brush: color_object
                rectangle rel>abs hdc
                ( 3 win-parameters ) Call FillRect ?win-error
                ;M

:M FillArea:    { left top right bottom color_object -- }
                color_object ?ColorCheck drop
                Brush: color_object
                left top right bottom SetRect: FillRect
                FillRect.AddrOf rel>abs hdc
                ( 3 win-parameters ) Call FillRect ?win-error
                ;M

:M Ellipse:     { left top right bottom -- }
                bottom right top left
                hdc Call Ellipse ?win-error ;M

:M Arc:         { left top right bottom x1 y1 x2 y2 -- }
                y2 x2 y1 x1 bottom right top left
                hdc Call Arc ?win-error ;M

:M FillCircle:  { x y radius -- }
                x radius - y radius - x radius + y radius +
                Ellipse: self ;M

:M Circle:      { x y radius -- }
                x radius - y radius - x radius + y radius +
                0 0 0 0 Arc: self ;M

:M CreateCompatibleBitmap: ( width height -- hbitmap )
                swap hdc
                Call CreateCompatibleBitmap ;M

;Class


  0 value #PAGES-UP
644 value SCREEN-WIDTH          \ Width of screen in bits
484 value SCREEN-HEIGHT         \ Height of screen in bits
  0 value PRINTING?             \ are we currently printing?
  6 value PRINTER-LPI           \ line per inch of the printer
 10 value PRINTER-CPI           \ characters per inch of the printer
 62 value PRINTER-ROWS          \ line per page of the printer
 80 value PRINTER-COLS          \ columns on printer page
  0 value PRINTER-#OUT          \ characters output on this line of printer
  0 value PRINTER-#LINE         \ lines output to the printer on this page
  0 value MULTI-PAGE?           \ multiple pages per page flag
  0 value PRINTER?              \ are we outputing to a line printer

\ rls added constants and values:

0 constant PR_SCALED
1 constant PR_RAW
2 constant PR_ISOTROPIC

pr_scaled value PRINTER-MODE
4800      value PRINTER-HSIZE
6300      value PRINTER-VSIZE
600       value PRINTER-HRES
600       value PRINTER-VRES

INTERNAL

: _calc_font_height ( --- points_high )
                84 printer-lpi / ;

EXTERNAL

defer calc_font_height

' _calc_font_height is calc_font_height

FALSE value auto-on?            \ automatic printer initialization, no dialog
FALSE value direct-print?
 TRUE value border?             \ should a border be printed on each page

:Class WinPrinter <SUPER WinDC

int page#
int #pages
int scalex
int scalexp                     
int scaley
int scaleyp                     
int borderx
int bordery
int drawlist
int drawoff
int drawing?
int drawmax
int penwidth
int page-ended?
int first-printed-page
int last-printed-page
int sequential-pages?
12 constant INT-BORDER-D        
17 constant EXT-BORDER-D        
int int-font                    
MAXSTRING bytes user-message-buf
MAXSTRING bytes user-title-buf
MAXSTRING bytes border-buf

ColorObject PRINTCOLOR
ColorObject PRINTFILLCOLOR

Font hFont
Font vFont
Font tFont
Font lFont

:M SetPrinterFont: ( a1 n1 -- )
                2dup SetFaceName: hFont
                2dup SetFaceName: vFont
                2dup SetFaceName: tFont
                     SetFaceName: lFont
                ;M

:M ClassInit:   ( -- )
                ClassInit: super
                    0 to #pages
                    1 to page#
                    0 to drawlist
                    0 to drawoff
                    0 to drawing?
                    0 to int-font
                FALSE to sequential-pages?
                65536 to drawmax
                   -1 to penwidth
                user-message-buf off
                user-title-buf off
                border-buf off
                                        \ set the default font type for printing
                s" Courier New" SetPrinterFont: self
                                               FW_NORMAL Weight: tFont
                                   CLIP_TT_ALWAYS ClipPrecision: tFont
                FIXED_PITCH 0x04 or FF_MODERN or PitchAndFamily: tFont
                                               FW_NORMAL Weight: lFont
                                   CLIP_TT_ALWAYS ClipPrecision: lFont
                FIXED_PITCH 0x04 or FF_MODERN or PitchAndFamily: lFont
                                               FW_NORMAL Weight: hFont
                                   CLIP_TT_ALWAYS ClipPrecision: hFont
                FIXED_PITCH 0x04 or FF_MODERN or PitchAndFamily: hFont
                                               FW_NORMAL Weight: vFont
                 CLIP_TT_ALWAYS CLIP_LH_ANGLES or ClipPrecision: vFont
  ( orientation in tenth degree increments )    900 Orientation: vFont
                FIXED_PITCH 0x04 or FF_MODERN or PitchAndFamily: vFont
                ;M

:M UserMessage: ( a1 n1 -- )
                user-message-buf place
                ;M

:M UserTitle:   ( a1 n1 -- )
                user-title-buf place
                ;M

:M SetPage:     ( n1 -- )       \ set the page number of next page printed
                to page#
                ;M

:M SequentialState: ( flag -- )
                to sequential-pages?
                ;M

:M RefLineColor: ( colorref -- )    \ version for the printer, pen width two
                         NewColor: PRINTCOLOR
                penwidth PenWidth: PRINTCOLOR
                Pen: PRINTCOLOR hDC Call SelectObject drop
                ;M

:M RefFillArea: { left top right bottom colorref -- }
                colorref NewColor: PRINTFILLCOLOR
                            Brush: PRINTFILLCOLOR
                left top right bottom SetRect: FillRect
                FillRect.AddrOf rel>abs hdc
                ( 3 win-parameters ) Call FillRect ?win-error
                ;M

\ printer resolution function

:M Width:       ( -- horizontal-dots-on-page )
                HORZRES hdc Call GetDeviceCaps
                ;M

:M Height:      ( -- vertical-dots-on-page )
                VERTRES hdc Call GetDeviceCaps
                ;M

:M DPI:         ( -- horizontal-dots-per-inch  vertical-dots-per-inch )
                LOGPIXELSX hdc Call GetDeviceCaps
                LOGPIXELSY hdc Call GetDeviceCaps
                ;M

\ Modes for SetStretchBltMode:
\
\       BLACKONWHITE  COLORONCOLOR  WHITEONBLACK  HALFTONE

:M SetStretchBltMode:  ( mode_value -- )
                hdc Call SetStretchBltMode drop
                ;M

:M Nullify:     ( -- )                  \ mark the printer hdc as not in use
                0 to hdc
                0 to drawlist
                0 to drawoff
                0 to drawing?
                ;M

: set-print-quality
                DPI: self drop
                quality-print dup 0<
                if
                        case    DMRES_HIGH   of DPI: self drop          endof
                                DMRES_MEDIUM of DPI: self drop 2 /      endof
                                DMRES_LOW    of DPI: self drop 4 /      endof
                                DMRES_DRAFT  of DPI: self drop 8 /      endof
                                                DPI: self drop swap
                        endcase
\ 09/08/95 10:13 tjz added the ELSE section to deal with the fact that
\ Windows NT 3.51 returns zero (0) for print quality, which was interpreted
\ as a very low resolution printer. Now we limit low resolution printing
\ to 32 DPI or higher. When a resolution lower than that is encountered,
\ then we just use the HIGHEST resolution available.
                else    dup 32 <                \ if really low resolution
                        if      drop            \ then use the highest
                                DPI: self drop  \ resolution available
                        then
                then    1 max / 1 max to penwidth ;

int font-height

: set-rows-cols   ( -- )                              
        Height: self  dup to PRINTER-VSIZE printer-lpi
        DPI: self nip dup to PRINTER-VRES  */ 1- to PRINTER-ROWS \ set lines per page
        Width: self  dup to PRINTER-HSIZE printer-cpi
        DPI: self drop dup to PRINTER-HRES */ to PRINTER-COLS    \ set columns per line
        ;

: set-print-params ( -- )                       \ rls - many changes
                Width:  self int-border-d / to borderx  \ calc scaling
                Height: self int-border-d / to bordery                  
                Width:  self borderx 2 * - 100 screen-width  */ to scalex
                Height: self bordery 2 * - 100 screen-height */ to scaley
                set-rows-cols
                calc_font_height to font-height

                printer-mode
                CASE    pr_scaled
                        OF      screen-width to printer-hsize
                                screen-height to printer-vsize
                                DPI: self nip  100 scalex */ to printer-vres
                                DPI: self drop 100 scaley */ to printer-hres
                                scalex to scalexp
                                scaley to scalexp
                        ENDOF
                        pr_raw
                        OF      DPI: self to printer-vres
                                to printer-hres
                                Height: self to printer-hsize
                                Width: self to printer-vsize
                        ENDOF
                        pr_isotropic
                        OF
                                Height: self DPI: self */ screen-width *
                                Width: self screen-height * u>
                                IF      scalex to scalexp
                                        Width: self DPI: self swap */
                                        int-border-d 2 - 100 *
                                        screen-width int-border-d * */ to scaleyp
                                        screen-width to printer-hsize
                                        Height: self int-border-d 2 - 100 *
                                        int-border-d scaleyp * */ to printer-vsize
                                ELSE    scaley to scaleyp
                                        Height: self 100 * DPI: self */
                                        int-border-d 2 - screen-height
                                        int-border-d * */ to scaleyp
                                        screen-height to printer-vsize
                                        Width: self int-border-d 2 - 100 *
                                        int-border-d scalexp * */ to printer-vsize
                                THEN
                                DPI: self nip  100 scalexp */ to printer-vres
                                DPI: self drop 100 scaleyp */ to printer-hres
                        ENDOF
                ENDCASE

                0 to printer-#out
                0 to printer-#line
                set-print-quality ;

:M Open:        ( -- f1 )               \ open the printer for use
                printing? 0=
                if      auto-on?
                        if      auto-print-init 
                        else         print-init
                        then    dup to hdc
                else    hdc
                then    dup
                if      set-print-params
                        0 to #pages
                then
                ;M

                                        \ rls February 5th, 2002 - 3:26
:M Open2:       ( bitmapped flags topage -- f1 )    \ open the printer for use
                printing? 0=
                if      auto-on?
                        if      2drop drop auto-print-init
                        else         print-init2
                        then    dup to hdc
                else    2drop drop hdc
                then    dup
                if      set-print-params
                        0 to #pages
                then
                ;M

:M AutoOpen:    ( -- f1 )               \ open the printer for use
                printing? 0=
                if      auto-print-init dup to hdc
                else    hdc
                then    dup
                if      set-print-params
                        0 to #pages
                then
                ;M

:M Close:       ( -- )                  \ close the printer
\                hdc
\                if      print-close
\                        0 to hdc
\                then
                ;M

:M Landscape:   ( -- )
                TRUE print-orientation dup to hdc
                if      set-print-params
                        0 to #pages
                then
                ;M

:M Portrait:    ( -- )
                FALSE print-orientation dup to hdc
                if      set-print-params
                        0 to #pages
                then
                ;M

:M Start:       ( -- )                  \ start a new page and document
                hdc 0=                  \ if not initialized
                penwidth -1 = or        \ or penwidth hasn't been set
                if      Open: self      \ -- f1 = true if ready to print
                else    hdc
                        set-print-params
                then
                if      print-start
                        0 to printer-#out
                        0 to printer-#line
                        true to printing?
                then
                ;M

:M End:         ( -- )                  \ end current page and document
                printing?
                if      end-page
                        true to page-ended?
                        print-end
                        false to printing?
                then
                ;M

:M Setup:       ( window_handle -- )
                print-setup ?dup
                if      to hdc
                        set-rows-cols
                then    ;M

:M DrawlistOpen: ( -- )
                drawlist 0=
                if      drawmax malloc to drawlist
                        drawlist 0=
                        s" Out of memory error while Printing!" ?ErrorBox
                        drawlist drawmax erase          \ prezero buffer
                        0 to drawoff
                then
                ;M

:M DrawlistClose: ( -- )
                drawlist
                if      drawlist release
                            0 to drawlist
                            0 to drawoff
                        65536 to drawmax
                then
                ;M

:M PrinterStart: ( -- )
                DrawlistOpen: self
                multi-page? 0=
                if      0 to drawoff
                then
                true to drawing?
                ;M

:M DrawingOff:  ( -- )
                false to drawing?
                ;M


 1 constant P_LINETO
 2 constant P_MOVETO
 3 constant P_TEXTOT
 4 constant P_TEXTOTR
 5 constant P_TEXTOTL
 6 constant P_LINECOLOR
 7 constant P_FILLAREA
 8 constant P_PAGE
 9 constant P_MPAGE
10 constant P_SETPIXEL
11 constant P_TEXTOTF
12 constant P_BEZIERTO
13 constant P_BEGINPATH
14 constant P_ENDPATH
15 constant P_FILLPATH
16 constant P_STROKEPATH
17 constant P_STROKEANDFILL

int tall?
int offsety
int c-page

\ Put a border around the screen text

: draw-border   { \ top left bottom right midwidth midheight foot1 foot2 head1 -- }
                border?                         \ print a border on page?
        if      Width:  self ext-border-d /                   to left  \ setup the location pointers
                Height: self ext-border-d /                   to top
                Width:  self ext-border-d / ext-border-d 1- * to right
                Height: self ext-border-d / ext-border-d 1- * to bottom
                Height: self  2 /                             to midheight
                Width:  self  2 /                             to midwidth
                bottom top 20 / 2 * +                         to foot1
                bottom top 20 / 7 * +                         to foot2
                top 5 / 3 *                                   to head1

                left  top    MoveTo: self       \ top left corner
                right top    LineTo: self       \ top line
                right bottom LineTo: self       \ right side line
                left  bottom LineTo: self       \ bottom line
                left  top    LineTo: self       \ left line

                multi-page? ?dup                \ split the pages per page
                if  2 =
                    if   Tall?
                         if   left     midheight MoveTo: self   \ left middle
                              right    midheight LineTo: self   \ right middle
                         else midwidth top       MoveTo: self   \ top middle
                              midwidth bottom    LineTo: self   \ bottom middle
                         then
                    else left     midheight MoveTo: self        \ left middle
                         right    midheight LineTo: self        \ right middle
                         midwidth top       MoveTo: self        \ top middle
                         midwidth bottom    LineTo: self        \ bottom middle
                    then
                then

                Handle: tFont SetFont: self             \ select the tiny font

                s" Date: "                                border-buf  place
                get-local-time time-buf >month,day,year"  border-buf +place
                s"   "                                    border-buf +place
                get-local-time time-buf >am/pm"           border-buf +place
                s"    "                                   border-buf +place

                left foot1
                border-buf count TextOut: self          \ display the text
                left foot2
                user-message-buf count TextOut: self    \ display user message

                #pages
                if      multi-page?
                        if      s" Pages: "               border-buf  place
                                page# 1- multi-page? * 1+
                                0 <# #s #>                border-buf +place
                                s"  to "                  border-buf +place
                                page# 1- multi-page? * 1+ multi-page? 1- +
                        else    s" Page: "                border-buf  place
                                page#
                        then    0 <# #s #>                border-buf +place
                        s"  of "                          border-buf +place
                        #pages 1+ 0 <# #s #>              border-buf +place
                        right                           \ from the right edge
                                                        \ back off by text width 
                        border-buf count GetTextExtent: self drop -
                        foot1
                        border-buf count TextOut: self  \ display page of pages
                then
                user-title-buf c@                       \ if header text?
                if      Handle: lFont SetFont: self     \ select line printer font
                        Width: self 2/                  \ middle of page
                                                        \ center the title
                        user-title-buf count GetTextExtent: self drop 2/ - 0max
                        head1
                        user-title-buf count TextOut: self \ display the header
                then
                Handle: hFont SetFont: self             \ select horiz font
        then    ;

: ?page-started ( -- )
                page-ended?
                if      start-page
                        false to page-ended?
                then    ;

: print-page?   ( -- f1 )
                page# first-printed-page >= ;

: p-page        ( a1 n1 -- a1 n1 )
                page-ended? 0=          \ don't do more than one in sequence
                IF      print-page?
                        IF      draw-border
                                end-page
                                true to page-ended?
                        THEN
                THEN    1 +to page# ;

: p-mpage       ( -- )
                c-page multi-page? 1- =
                if      p-page
                        0 to c-page
                else    1 +to c-page
                then    ;

: s/i-scalex    ( -- scalex )
                printer-mode pr_scaled =
                IF      scalex
                ELSE    scalexp
                THEN ;

: x-position    ( logicalx -- physicalx )
                PRINTER-MODE pr_raw = ?EXIT
                multi-page? ?dup
                if      2 =
                        if      tall?
                                if      s/i-scalex
                                else    c-page 1 and
                                        if      screen-width 104 100 */ +
                                        else    screen-width 50 / -
                                        then    s/i-scalex 2/
                                then
                        else    c-page 1 and
                                if      screen-width 104 100 */ +
                                else    screen-width 50 / -
                                then    s/i-scalex 2/
                        then
                else    s/i-scalex
                then    100 */ borderx + ;

: s/i-scaley    ( -- scaley )
                printer-mode pr_scaled =
                IF      scaley
                ELSE    scaleyp
                THEN ;

: y-position    ( logicaly -- physicaly )
                PRINTER-MODE pr_raw = ?EXIT
                multi-page? ?dup
                if      2 =
                        if      tall?
                                if      c-page 1 and
                                        if      screen-height 100 100 */ +
                                        else    screen-height 50 / -
                                        then    s/i-scaley 2/
                                else    s/i-scaley
                                then
                        else    c-page 2 and
                                if      screen-height 100 100 */ +
                                else    screen-height 50 / -
                                then    s/i-scaley 2/
                        then
                else    s/i-scaley
                then    98 */ bordery + ;

: p-lineto      ( a1 n1 -- a1 n1 )
                print-page? 0= ?exit
                ?page-started
                over 1+ dup sw@ x-position
                swap    2 + sw@ y-position LineTo: self ;

: p-moveto      ( a1 n1 -- a1 n1 )
                print-page? 0= ?exit
                ?page-started
                over 1+ dup sw@ x-position
                swap    2 + sw@ y-position MoveTo: self ;

: p-textot      ( a1 n1 -- a1 n1 )      \ horizontal text (normal)
                print-page? 0= ?exit
                ?page-started
                over 1+  dup sw@           x-position
                swap 2 + dup sw@ offsety + y-position
                swap 2 +     count        TextOut: self ;

: p-textotr     ( a1 n1 -- a1 n1 )      \ vertical text
                print-page? 0= ?exit
                ?page-started
                over 1+  dup sw@           x-position
                swap 2 + dup sw@ offsety + y-position
                swap 2 +     count Handle: vFont SetFont: self
                TextOut: self
                Handle: hFont SetFont: self ;

: p-textotl     ( a1 n1 -- a1 n1 )      \ line printer text
                print-page? 0= ?exit
                ?page-started
                over 1+  dup sw@ char-width * x-position
                swap 2 + dup sw@ screen-height printer-rows 1+
                */ y-position
                swap 2 + count Handle: lFont SetFont: self
                TextOut: self
                Handle: hFont SetFont: self ;

: p-textotf     ( a1 n1 -- a1 n1 )      \ font-specifed text out
                print-page? 0= ?exit
                ?page-started
                over 1+ @ to int-font   \ get font object
                over 5 + dup sw@
                swap 2 + dup sw@
                swap 2 + count
                Handle: int-font SetFont: self
                TextOut: self
                Handle: hfont SetFont: self ;

: p-linecolor   ( a1 n1 -- a1 n1 )
                print-page? 0= ?exit
                ?page-started
                over 1+ @ ( colorref ) RefLineColor: self ;

: p-fillarea    ( a1 n1 -- a1 n1 )
                print-page? 0= ?exit
                ?page-started
                over 1+  >r r@ sw@ x-position                   
                r> 2 +   >r r@ sw@ y-position                   
                r> 2 +   >r r@ sw@ x-position                   
                r> 2 +   >r r@ sw@ y-position                   
                r> 2 +       @ ( colorref ) RefFillArea: self ;

: p-setpixel    ( a1 n1 -- a1 n1 )
                print-page? 0= ?exit
                ?page-started
                over 1+ >r
                r@     sw@ 1- x-position                        
                r@ 2 + sw@ 1- y-position                        
                r@     sw@ 1+ x-position                        
                r@ 2 + sw@ 1+ y-position                        
                r> 4 +   @ ( colorref ) RefFillArea: self ;

: p-bezierto    ( a1 n1 -- a1 n1 )                      \ only works RAW
                over dup 2 + swap 1+ c@ PolyBezierTo: self ;

: p-beginpath   ( a1 n1 -- a1 n1 )
                BeginPath: self ;

: p-endpath     ( a1 n1 -- a1 n1 )
                EndPath: self ;

: p-fillpath    ( a1 n1 -- a1 n1 )
                FillPath: self ;

: p-strokepath  ( a1 n1 -- a1 n1 )
                StrokePath: self ;

: p-strokeandfill ( a1 n1 -- a1 n1 )
                StrokeAndFillPath: self ;

:M SetPageLimits:   ( -- )
                get-frompage to first-printed-page
                get-topage   to  last-printed-page
                multi-page?
                IF      first-printed-page 1 umax
                        1- multi-page? / 1+ to first-printed-page
                        last-printed-page 1 umax
                        1- multi-page? / 1+ to last-printed-page
                THEN ;M

:M PrinterEnd:   ( -- )
        drawlist
        IF      SetPageLimits: self                    
                0 drawlist drawoff + !                  \ NULL terminate list
                0 to c-page
                0 to page-ended?
                sequential-pages? 0=
                if      1 to page#
                then
                set-print-quality                       \ init penwidth
\                Width:  self 12 / to borderx            \ calc scaling
\                Height: self 12 / to bordery
\                Width:  self borderx 2 * - 100 screen-width  */ to scalex
\                Height: self bordery 2 * - 100 screen-height */ to scaley
                Height: self Width: self > to tall?     \ tall page flag

\ tiny font for page labeling
                0 to offsety
                9  scalex          110               */   Width: tFont
                12 scaley tall? if 195 else 140 then */   Height: tFont
                Create: tFont

\ line printer font
                char-width  scalex tall? if 110 else 130 then */
                multi-page? ?dup if 2 = if 56 100 */ else 2/ then then  Width: lFont
                font-height scaley tall? if 195 else 140 then */
                multi-page? ?dup if 2 = if 75 100 */ else 2/ then then Height: lFont
                Create: lFont

\ horizontal font (normal)
                char-width  scalex tall? if 110 else 130 then */
                multi-page? ?dup if 2 = if 56 100 */ else 2/ then then  Width: hFont
                font-height scaley tall? if 4 to offsety 195 else 140 then */
                multi-page? ?dup if 2 = if 80 100 */ else 2/ then then Height: hFont
                Create: hFont

\ vertical font
                char-width  scalex tall? if 110 else 130 then */
                multi-page? ?dup if 2 = if 56 100 */ else 2/ then then  Width: vFont
                font-height scaley tall? if 195 else 140 then */
                multi-page? ?dup if 2 = if 80 100 */ else 2/ then then Height: vFont
                Create: vFont
                
                Start:  self
                drawlist            \ starting at the top of the list
                begin   count dup   \ proceed through each record
                                    \ stop if not within desired page range
                        page# last-printed-page <= and
                while   over c@
                        case   P_LINETO of p-lineto        endof
                               P_MOVETO of p-moveto        endof
                               P_TEXTOT of p-textot        endof   \ scaled
                              P_TEXTOTR of p-textotr       endof   \ rotated
                              P_TEXTOTL of p-textotl       endof   \ LPT
                              P_TEXTOTF of p-textotf       endof   \ specific font
                            P_LINECOLOR of p-linecolor     endof
                             P_FILLAREA of p-fillarea      endof
                                 P_PAGE of p-page          endof
                                P_MPAGE of p-mpage         endof
                             P_SETPIXEL of p-setpixel      endof
                             P_BEZIERTO of p-bezierto      endof
                            P_BEGINPATH of p-beginpath     endof
                              P_ENDPATH of p-endpath       endof
                             P_FILLPATH of p-fillpath      endof
                           P_STROKEPATH of p-strokepath    endof
                        P_STROKEANDFILL of p-strokeandfill endof
                        endcase
                        +
                repeat  2drop

                page-ended? 0=
                if      p-page
                        sequential-pages? 0=
                        if      first-printed-page to page#
                        then
                then
                print-end
                false to printing?

                Delete: hFont
                Delete: vFont
                Delete: tFont
                Delete: lFont
        then    false to drawing?
        hdc
        if      print-close
                0 to hdc
        then
        ;M

: drawlist_overflow? ( -- )
                drawoff drawmax MAXSTRING - u>
                if      drawmax 65536 + dup drawlist realloc
                        s" Failed to Expand the DRAWLIST!" ?ErrorBox
                        to drawlist                     \ set new buffer addr
                        drawlist drawmax + 65536 erase  \ clear extra buffer
                        to drawmax                      \ set new buffer len
                then    ;

: d-c,          ( c1 -- )               \ compile a BYTE
                drawlist drawoff + c!
                   1 +to drawoff drawlist_overflow? ;

: d-w,          ( w1 -- )               \ compile a WORD
                drawlist drawoff + w!
                2 +to drawoff drawlist_overflow? ;

: d-,           ( c1 -- )               \ compile a CELL
                drawlist drawoff + !
                cell +to drawoff drawlist_overflow? ;

MAXCOUNTED 10 - CONSTANT string-max     \ later 6 is added to this, and the sum
                                        \ must be less than MAXCOUNTED

: d-",          ( a1 n1 -- )            \ compile a string
                string-max min          \ clip to max allowed string
                dup>r
                drawlist  drawoff + place
                r> 1+ +to drawoff drawlist_overflow? ;

int lastcall

:M PrinterLineto: ( x y -- )
                drawing?        \ we are drawing
        if      lastcall P_MOVETO =
                if      drawlist drawoff + >r
                        2dup r@ 2 - sw@ =
                        swap r> 4 - sw@ = and 0=
                else    true
                then
           if
                5 d-c,          \ record data length is 5 bytes
                P_LINETO to lastcall
                P_LINETO  d-c,  \ opcode
                swap d-w, d-w,  \ x and y
           else 2drop
                -6 +to drawoff
                0 drawlist drawoff + !  \ null terminate list
           then
        else    2drop
        then    ;M

:M PrinterMoveto: ( x y -- )
                drawing?        \ we are drawing
        if      5 d-c,          \ record data length is 5 bytes
                P_MOVETO to lastcall
                P_MOVETO  d-c,  \ opcode
                swap d-w, d-w,  \ x and y
        else    2drop
        then    ;M

:M PrinterBezierTo: ( addr cnt -- )         \ cnt is number of points
                \ in the array at addr
        drawing?
        IF      dup 3 mod
                IF      2drop           \ error if not multiple of 3
                ELSE    P_BEZIERTO to lastcall
                        BEGIN   dup 30 >        \ we can't exceed 253/(8*cnt)
                        WHILE   30 -            \ adjust cnt
                                242 d-c,
                                P_BEZIERTO d-c,
                                30 d-c,         \ count of "points"
                                over 240 d-",
                                30 +
                        REPEAT
                        dup
                        IF      dup 8 * 2 + c,
                                P_BEZIERTO d-c,
                                dup d-c,
                                8 * d-",
                        ELSE    2drop
                        THEN
                THEN
        ELSE    2drop
        THEN    ;M

:M PrinterBeginPath: ( -- )
        drawing?
        if      1 d-c,                  \ record length is 1 byte + count
                P_BEGINPATH to lastcall
                P_BEGINPATH d-c,        \ opcode
\ April 20th, 1998 - 16:34 tjz removed
\       else    drop
        then    ;M

:M PrinterEndPath: ( -- )
        drawing?
        if      1 d-c,                  \ record length is 1 byte + count
                P_ENDPATH to lastcall
                P_ENDPATH d-c,          \ opcode
\ April 20th, 1998 - 16:34 tjz removed
\       else    drop
        then    ;M

:M PrinterStrokePath: ( -- )
        drawing?
        if      1 d-c,                  \ record length is 1 byte + count
                P_STROKEPATH to lastcall
                P_STROKEPATH d-c,        \ opcode
\ April 20th, 1998 - 16:34 tjz removed
\       else    drop
        then    ;M

:M PrinterFillPath: ( -- )
        drawing?
        if      1 d-c,                  \ record length is 1 byte + count
                P_FILLPATH to lastcall
                P_FILLPATH d-c,         \ opcode
\ April 20th, 1998 - 16:34 tjz removed
\       else    drop
        then    ;M

:M PrinterStrokeAndFill: ( -- )
        drawing?
        if      1 d-c,                      \ record length is 1 byte + count
                P_STROKEANDFILL to lastcall
                P_STROKEANDFILL d-c,        \ opcode
\ April 20th, 1998 - 16:34 tjz removed
\       else    drop
        then    ;M

:M PrinterTextOut: ( x y addr len -- )
        drawing?                        \ we are drawing
        if      string-max min          \ clip to max allowed string
                dup 6 +   d-c,  \ record length 2 words + opcode + string cnt
                P_TEXTOT  to lastcall
                P_TEXTOT  d-c,  \ opcode
                2swap
                swap d-w, d-w,  \ x and y
                d-",            \ text string
        else    4drop
        then    ;M

:M PrinterTextOutFont: ( x y addr len font_object -- )
        drawing?
        IF      >r string-max min
                dup 10 + d-c,   \ str_len+draw_len opcode font4 x2 y2 str len
                P_TEXTOTF to lastcall
                P_TEXTOTF d-c,  \ opcode
                r> d-,          \ font object
                2swap swap d-w, \ x-position (raw)
                d-w,            \ y-position (raw)
                d-",            \ string
        ELSE    4drop drop
        THEN    ;M

:M PrinterRotatedTextOut: ( x y addr len -- )
                drawing?                \ we are drawing
        if      string-max min          \ clip to max allowed string
                dup 6 +   d-c,  \ record length 2 words + opcode + count
                P_TEXTOTR to lastcall
                P_TEXTOTR d-c,  \ opcode
                2swap
                swap d-w, d-w,  \ x and y
                d-",            \ text string
        else    4drop
        then    ;M

:M LPTPrinterTextOut: ( addr len -- )
                drawing?                \ we are drawing
        if      string-max min          \ clip to max allowed string
                dup 6 +   d-c,  \ record length 2 words + opcode + string cnt
                P_TEXTOTL to lastcall
                P_TEXTOTL d-c,  \ opcode
                printer-#out  d-w,      \ col
                printer-#line d-w,      \ row
                d-",                    \ text string
        else    2drop                  
        then    ;M

:M LPTPrinterIndentTextOut: ( indent addr len -- )       \ rls - new function
        drawing?                                \ we are drawing
        IF      string-max min                  \ clip to max allowed string
                dup 6 +   d-c,  \ record length 2 words + opcode + string cnt
                P_TEXTOTL to lastcall
                P_TEXTOTL d-c,                  \ opcode
                rot printer-#out + d-w,         \ adjusted col
                printer-#line d-w,              \ row
                d-",                            \ text string
        ELSE    drop 2drop
        THEN    ;M

\ January 20th, 1997 tjz
\ changed this definition to save the color reference, rather than saving the
\ color object, since some applications, particularly WINDEMO.F, use the same
\ color object over and over again, just changing the color in the object.
\ We now save the color reference, so we can correctly regenerate the needed
\ color when printing occurs.

:M PrinterLineColor: { color_object -- }
                color_object ?ColorCheck drop
                drawing?
        if      5 d-c,                  \ record length is 5 bytes + count
                P_LINECOLOR to lastcall
                P_LINECOLOR d-c,        \ opcode
                Color: color_object d-, \ compile the colorref of cur color obj
        then    ;M

:M PrinterFillArea: { left top right bottom color_object -- }
                color_object ?ColorCheck drop
                drawing?
        if      13 d-c,                 \ record is 13 bytes + count
                P_FILLAREA to lastcall
                P_FILLAREA d-c,         \ opcode
                left  d-w, top    d-w,
                right d-w, bottom d-w,
                Color: color_object d-, \ compile the colorref of cur color obj
        then    ;M

:M PrinterPage:  ( -- )
                drawing?
        if      1 d-c,                  \ record length is 1 byte + count
                P_PAGE to lastcall
                P_PAGE d-c,             \ opcode
                1 +to #pages
        then    ;M

:M PrinterMultiPage: ( -- )
                drawing?
        if      1 d-c,                  \ record length is 1 byte + count
                P_MPAGE to lastcall
                P_MPAGE d-c,            \ opcode
                1 +to #pages
        then    ;M

:M PrinterSetPixel: { xpos ypos color_object -- }
                color_object ?ColorCheck drop
                drawing?
        if      9 d-c,                  \ record is 9 bytes + count
                P_SETPIXEL to lastcall
                P_SETPIXEL d-c,         \ opcode
                xpos d-w,
                ypos d-w,
                Color: color_object d-, \ compile the colorref of cur color obj
        then    ;M

1 bytes emit_buffer

:M Page:        ( -- )                  \ start a new page
                multi-page?
                if      PrinterMultiPage: self
                else         PrinterPage: self
                then
                0 to printer-#line
                0 to printer-#out
                ;M

:M Cr:          ( -- )
                1 +to printer-#line
                0  to printer-#out
                printer-#line printer-rows >=
                if      Page: self
                then
                ;M

: >tab          ( -- )
                printer-#out tabwidth / 1+ tabwidth *  \ TAB-SIZE is not right, but ok for now
                printer-cols 1- min printer-#out -
                begin   dup 0>
                while   dup spcs-max min
                        spcs over dup>r LPTPrinterTextOut: self
                        r> +to printer-#out
                        -
                repeat  drop ;

:M ?Cr:         ( n1 -- )
                printer-#out + printer-cols >
                if      Cr: self
                then
                ;M

:M Emit:        ( c1 -- )
                emit_buffer c!
                emit_buffer 1 LPTPrinterTextOut: self
                1 +to printer-#out
                ;M

:M Type:        ( a1 n1 -- )
                BEGIN   2dup k_tab scan 2dup 2>r nip -
                        dup>r
                        LPTPrinterTextOut: self
                        r> +to printer-#out
                        2r> dup
                WHILE   >tab
                        1 /string
                REPEAT  2drop
                ;M

:M IndentType:  ( offset a1 n1 -- )                     
                2 pick over + >r
                LPTPrinterIndentTextOut: self
                r> +to printer-#out
                ;M

;CLASS

WinPrinter ThePrinter

INTERNAL

: start-printer  ( -- f1 )
                direct-print?
                if true to auto-on?
                then
                Open: ThePrinter dup
                if      PrinterStart: ThePrinter
                then    ;

EXTERNAL

                                \ rls February 5th, 2002 - 3:36
: start-printer2  ( bitmapped flags topage -- f1 )
                direct-print?
                if true to auto-on?
                then
                Open2: ThePrinter dup
                if      PrinterStart: ThePrinter
                then    ;

: page-setup    ( -- )
                conhndl Setup: ThePrinter  ;

: start-scaled  ( -- f1 )
                pr_scaled to printer-mode
                start-printer ;

                        \ rls February 5th, 2002 - 8:48
: start-scaled2  ( bitmapped flags topage -- f1 )
                pr_scaled to printer-mode
                start-printer2 ;

: start-isotropic  ( -- f1 )
                pr_isotropic to printer-mode
                start-printer ;

                        \ rls February 5th, 2002 - 8:48
: start-isotropic2  ( bitmapped flags topage -- f1 )
                pr_isotropic to printer-mode
                start-printer2 ;

: start-raw  ( -- f1 )
                pr_raw to printer-mode
                start-printer ;

                        \ rls February 5th, 2002 - 8:48
: start-raw2  ( bitmapped flags topage -- f1 )
                pr_raw to printer-mode
                start-printer2 ;

: print-multi-page ( -- )
                multi-page?
                if         PrinterEnd: ThePrinter
                        DrawlistClose: ThePrinter
                        false to multi-page?
                        SetPageLimits: ThePrinter
                then    ;

: page-scaled   ( -- )
                Page: ThePrinter ;

: print-scaled  ( -- )
                multi-page? 0=
                if             PrinterEnd: ThePrinter
                            DrawlistClose: ThePrinter
                else     PrinterMultiPage: ThePrinter
                               DrawingOff: ThePrinter
                        false to printing?
                then    ;

: single-page   ( -- )
                multi-page?
                if      s" Spooling Printing to Windows" "message
                        print-multi-page
                        300 ms message-off
                then    ;

synonym 1page    single-page
synonym one-page single-page

: two-page      ( -- )
                2 to multi-page?
                SetPageLimits: ThePrinter ;

synonym 2page two-page

: four-page     ( -- )
                4 to multi-page?
                SetPageLimits: ThePrinter ;

synonym 4page four-page

INTERNAL

: _pemit        ( c1 -- )
                Emit: ThePrinter ;

: _ptype        ( a1 n1 -- )
                0max bounds
                ?do     i c@ Emit: ThePrinter
                loop    ;

: _pgetcolrow   ( -- cols rows )
                printer-cols printer-rows ;

: _pgetxy       ( -- x y )
                printer-#out printer-#line ;

: _pgotoxy      ( x y -- )
                to printer-#line to printer-#out ;

: _pcr          ( -- )
                Cr: ThePrinter ;

: _p?cr         ( n1 -- )
                ?Cr: ThePrinter ;

: _ppage        ( -- )
                Page: ThePrinter ;

: _pcol         ( n1 -- )
                printer-cols 1- min printer-#out - spaces ;

EXTERNAL

: PRINTER       ( -- )
                true to printer?
                start-scaled
                if      ['] _pemit      is emit
                        ['] _ptype      is type
                        ['] _pgetcolrow is getcolrow
                        ['] _pgetxy     is getxy
                        ['] _pgotoxy    is gotoxy
                        ['] _pcr        is cr
                        ['] _p?cr       is ?cr
                        ['] _ppage      is page
                        ['] _pcol       is col
                else    false to printer?
                then    ;

INTERNAL

: console-forth-io ( -- )
                print-scaled
                direct-print?
                if      false to auto-on?
                then
                false to direct-print?
                false to printer? ;

' FORTH-IO is console

FORTH-IO-CHAIN CHAIN-ADD console-forth-io

EXTERNAL

: PRINT         ( -- )
                printer
                printer?
                if      source UserTitle: ThePrinter
                        interpret
                then    console ;

: $fprint       { the-name \ message$ fpr$ locHdl -- } \ type filename a1 to the printer
                MAXSTRING LocalAlloc: fpr$
                MAXSTRING localAlloc: message$
                the-name $open abort" Couldn't open file!" to locHdl
                cur-line off
                printer
                printer?
                if      s" Printing file: " message$  place
                        open-path$ count    message$ +place
                                            message$ count "message
                        s" File: "          message$  place
                        open-path$ count    message$ +place
                                            message$ count UserMessage: ThePrinter
                        cr
                        begin   fpr$ dup MAXCOUNTED locHdl fread-line
                                abort" Read Error"
                        while   Type: ThePrinter cr
                        repeat  2drop
                then    console
                locHdl fclose-file drop
                message-off ;

: FPRINT        ( -<name>- )
                /parse-word $fprint ;

: 2print        ( -- )
                two-page fprint single-page ;

: 4print        ( -- )
                four-page fprint single-page ;

80 value MAXCONCOLS

: #print-screen ( start_line lines -- ) \ print a range of lines from saved
                                        \ Forth screen buffer
                cursor-off
                #pages-up ?dup
                if      2 =
                        if      two-page
                        else    four-page
                        then
                then
                printer
                printer?
        if      ( -- start lines )
                &the-screen -rot
                ( -- start lines ) bounds
                do      dup getmaxcolrow drop i * +       \ line starting addr
                        cols MAXCONCOLS max getmaxcolrow drop min  \ addr len
                        Type: ThePrinter
                        Cr: ThePrinter                             \ next line
                loop    drop
        else    2drop
        then    console single-page cursor-on ;

: print-screen  ( -- )          \ print the physical screen
                getrowoff rows
                #print-screen ;

: print-console ( -- )       \ print all lines used in screen save buffer
                0 getrowoff rows +
                #print-screen ;

INTERNAL

: _printer-release ( -- )               \ release the printer DC if allocated
                DrawlistClose: ThePrinter
                        Close: ThePrinter ;

unload-chain chain-add-before _printer-release    \ add to termination chain

: _nullify-printer ( -- )               \ mark printer as not used yet
                Nullify: thePrinter ;

initialization-chain chain-add _nullify-printer

EXTERNAL

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ File dialog Class
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

:Class FileDialogs      <Super  Object

max-handle bytes szFile
max-handle bytes szDir
int szFilter
int szTitle

:M ClassInit:   ( -- )
                ClassInit: super
                0 szDir !
                s" UNTITLED" szFile place
                             szFile +NULL
                here 1+ to szTitle  ,"text"
                max-handle here szTitle - - allot  \ extend to max string
                here 1+ to szFilter ,"text"        \ lay in filter, then
                max-handle here szFilter - - allot \ extend to max string
                ;M

:M SetDir:      ( a1 n1 -- )    \ set the dialog directory string
                max-handle 2 - min szDir place  \ lay in the directory
                szDir +NULL                     \ null terminate
                szDir count upper               \ make path uppercase
                szDir ?-\                       \ remove trailing \
                ;M

:M GetDir:      ( -- a1 n1 )    \ get the current dialog directory string
                szDir count
                ;M

:M SetTitle:    ( a1 n1 -- )
                szTitle 1- place        \ lay in new string
                szTitle 1- +NULL        \ null terminate it
                ;M

\ a new file filter string would be in the following format, with vertical
\ bars separating filter name from filter spec, and between filter spec
\ and succeeding filter names.
\ A maximum of 255 characters is allowed for the total filter specs string
\ s" Forth Files (*.f)|*.f|Text Files (*.txt)|*.txt|All Files (*.*)|*.*|"


:M SetFilter:   ( a1 n1 -- )            \ set new file filter spec
                szFilter 1- place       \ lay in new string
                szFilter 1- +NULL       \ null terminate it
                ;M

:M GetFilter:   ( -- a1 n1 )            \ return current file filter string
                szFilter 1- count
                ;M

: run-dialog    ( owner_handle dialog-func-cfa -- a1 )
                2>r
                szFile count "to-pathend" szFile place
                szFile +NULL
                szFile      rel>abs     \ takes a counted string for filename
                szDir    1+ rel>abs
                szTitle     rel>abs
                szFilter    rel>abs
                2r> execute abs>rel
\ April 27th, 1998 - 9:19 tjz removed, duplication
\                dup count upper
                dup count 2dup upper "path-only" szDir place
                ;

;Class

:Class FileNewDialog    <Super  FileDialogs

:M Start:       ( owner_handle -- a1 )
                ['] new-dialog run-dialog
                ;M

:M Start2:      ( filterindex owner_handle -- a1 )
                ['] new-dialog2 run-dialog
                ;M

;Class

:Class FileOpenDialog   <Super  FileDialogs

:M Start:       ( owner_handle -- a1 )
                ['] open-dialog run-dialog
                ;M

;Class

FileOpenDialog EditForth "Edit Forth File" "Forth Files (*.f)|*.f|Text Files (*.txt)|*.txt|All Files (*.*)|*.*|"


: edit-forth    ( -- )
                conhndl start: EditForth dup c@
                if      count pocket place
                        0 pocket $edit
                else    drop
                then    ;

FileOpenDialog LoadForth "Load Forth File" "Forth Files (*.f)|*.f|All Files (*.*)|*.*|"


: load-forth    ( -- )
                conhndl start: LoadForth dup c@
                if      count pocket place
                        s" FLOAD "   "pushkeys
                        pocket count "pushkeys
                        0x0D pushkey
                else    drop
                then    ;

FileOpenDialog PrintForth "Print Forth File" "Forth Files (*.f)|*.f|Text Files (*.txt)|*.txt|All Files (*.*)|*.*|"

: print-forth    ( -- )
                conhndl start: PrintForth dup c@
                if      count pocket place
                        #pages-up ?dup
                        if      2 =
                                if      two-page
                                else    four-page
                                then    pocket $fprint
                                single-page
                        else    pocket $fprint
                        then
                else    drop
                then    ;

FileOpenDialog EditLog "Edit Key Log File" "Log Files (*.LOG)|*.LOG|Text Files (*.txt)|*.txt|All Files (*.*)|*.*|"


: edit-log      ( -- )
                conhndl start: EditLog dup c@
                if      count pocket place
                        0 pocket $edit
                else    drop
                then    ;

:Class FileSaveDialog   <Super  FileDialogs

:M Start:       ( owner_handle -- a1 )
                ['] save-dialog run-dialog
                ;M

;Class

FileSaveDialog SaveForth "Save Forth Image" "Image Files (*.exe)|*.exe|All Files (*.*)|*.*|"

MODULE

\S *****************************************************************************
\S *****************************************************************************
\S ********* Don't need the following definitions any more, now that  **********
\S ********* Win32Forth has Copy Console, and Cut Console operations. **********
\S *****************************************************************************
\S *****************************************************************************

FileSaveDialog SaveConsole "Save Forth Console Buffer" "Text Files (*.txt)|*.txt|All Files (*.*)|*.*|"

\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\ Console window save functions
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

INTERNAL

: find_last_console_line ( -- n1 )
                        &the-screen dup getmaxcolrow * bounds
                        do      i getmaxcolrow drop -trailing nip
                                if      drop i  \ new last line addr with text
                                then
     getmaxcolrow drop +loop    \ return the real buffer end address
                        &the-screen -                   \ remove buffer base
                        getmaxcolrow drop / ;

create console-save$ here 128 + ," CONSOLE.TXT" here - 0max allot

: save-console  ( -- )
                console-save$ c@ 0=
                if      conhndl start: SaveConsole dup c@
                        if      count 127 min console-save$ place
                                \ make sure file doesn't already exist
                                console-save$ count delete-file drop
                                true
                        else    drop false
                        then
                else    true
                then
                if      console-save$ count r/w open-file
                        if      drop
                                console-save$ count r/w create-file
                                s" Console Buffer Save Error!" ?ErrorBox
                        else    dup file-append drop
                        then
                        dup>r
                        s" ***** Screen Save Start: " r@ write-file drop
                        get-local-time
                        time-buf dup >month,day,year"   r@ write-file drop
                                    s"  - "             r@ write-file drop
                                     >time"             r@ write-file drop
                        crlf$ count                     r@ write-file drop
                        &the-screen                     \ buffer base
                        find_last_console_line 2 +      \ plus two lines
                        getmaxcolrow nip min            \ clip to valid max
                        getmaxcolrow drop * bounds      \ line address range
                        ?do     dup i getmaxcolrow drop -trailing
                                rot write-file drop
                                dup crlf$ count rot write-file drop
     getmaxcolrow drop +loop    drop
                        s" ***** Screen Save End: " r@ write-file drop
                        get-local-time
                        time-buf dup >month,day,year"   r@ write-file drop
                                    s"  - "             r@ write-file drop
                                     >time"             r@ write-file drop
                        crlf$ count                     r@ write-file drop
                        r> close-file drop
                then    ;

: save-console-as  ( -- )
                console-save$ off
                save-console ;

MODULE

