// $Id: forth.c 1.1 1994/04/01 07:51:15 andrew Exp $

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include "forth.h"
#include "term.h"
//#include "forthdll.h"

HANDLE the_instance;
HANDLE prev_instance;
LPSTR cmd_line;
int cmd_show;

char dictionary[81];                // dictionary name
char StartupName[81] = "extended";
char sbuf[300];

// HGLOBAL hmem = NULL;             // handle to memory block
BOOL doingdll = FALSE;              // are we running as a DLL?
int *imageL;                        // access forth as LONGs
char *imageB, *himageB;             // access forth and headers aas BYTEs
char *resourceimageB;               // pointer to the resource image
int imagesize;                      // size of image
int allocationsize;                 // how much space is allocated for Forth's use
int headallocationsize;             // how much space is allocated for Forth's symbol use
int actualsize;                     // how much space is used for Forth's use
int headactualsize;                 // how much space is used for Forth's symbols
int headseparation;                 // separation between code and heads in bytes
int *reservedaddress;
int reservedbytes;
int winsize = 0;                    // current window size state

EXCEPTION_RECORD the_exception;     // storage for exception handling
CONTEXT the_context;
HRSRC rHndl;
HGLOBAL rGlobal;

#define MAGIC 26350037              // magic # at imageL[1]

//////////////////// Function Table ////////////////////
 
ENTRY Bye (int exit_code)
{
        unload ();
        exit (exit_code);
        return 0;
}

ENTRY getstartup (void)
{
        return (int)StartupName;
}

ENTRY InitConsole (void)
{
        return init (the_instance, prev_instance, cmd_show);
}

// -------------------- Memory Allocation --------------------

ENTRY Malloc (int size)
{
/*
    void *addr = malloc (size+512);
    memset (addr, 0x55, size+512);
    *(int *)addr = size;
        return (int) addr+256;
*/
    return (int) malloc (size+32);
}

ENTRY Free (char* addr)
{
/*    
    int len = *(int *)(addr-256);

    char *p = addr-252;
    while (p < addr) 
        if (*p++ != 0x55)
            break;

    p = addr+len;
    while (p < addr+len+256) 
        if (*p++ != 0x55)
            break;

        free (addr-256);

*/
    free (addr);
        return 0;
}

ENTRY Realloc (void* addr, int size)
{
        return (int) realloc (addr, size);
}

// ------------- Current window Size State ----------------

ENTRY SizeState ()
{
        return (int) winsize;
}


// -------------------- File I/O --------------------

ENTRY open_file (char *addr, unsigned len, int fam)
{
        char name[256];
        char mode[4] = "rt";

        if (len > 255) len = 255;
        memcpy(name, addr, len);
        name[len] = 0;

        if (fam) strcat(mode, "+");

        return (int) fopen(name, mode);
}

ENTRY make_file (char *addr, unsigned len)
{
        char name[256];
        char mode[4] = "w+";

        if (len > 255) len = 255;
        memcpy(name, addr, len);
        name[len] = 0;

        return (int) fopen(name, mode);
}

ENTRY close_file (FILE *f)
{
        return fclose(f);
}

ENTRY file_position (FILE *f)
{
        return (int) ftell (f);
}

ENTRY seek_file (FILE *f, int origin, int offset)
{
        return fseek (f, offset, origin);
}

ENTRY read_file (FILE *f, int len, char *addr)
{
        return fread (addr, 1, len, f);
}

ENTRY read_line (char *addr, int len, FILE *f)
{
        // read a line from a file
        // return length of line or -1=eof, -2=error.

        int n;

        if (!fgets(addr, len, f))
                return (feof(f) ? -1 : -2);

        n = strlen(addr);
        if (n > 0 && addr[n-1] == '\n')  n = n - 1;
        return n;
}

ENTRY save (void* addr, int len, char* faddr, unsigned flen)
{
        FILE *f;
        char name[256];

        if (flen > 255) flen = 255;
        memcpy(name, faddr, flen);
        name[flen] = 0;

        f = fopen (name, "wb");
        if (f == NULL) return 0;

        len = fwrite (addr, 1, len, f);
        fclose (f);
        return len;
}

// -------------------- Load Procedures from DLLs --------------------

ENTRY load_library (char *addr, unsigned len)
{
        char name[256];
        HINSTANCE laddr;

        if (len > 255) len = 255;
        memcpy(name, addr, len);
        name[len] = 0;
        laddr = LoadLibrary(name);
        return (int) laddr;
}

ENTRY free_library (HINSTANCE name)
{
        return (int)FreeLibrary(name);
}

ENTRY get_proc (char *addr, unsigned len, HINSTANCE handle)
{
        char name[256];
        int paddr;

        if (len > 254) len = 254;
        memcpy(name, addr, len);
        name[len] = 0;
        paddr = (int) GetProcAddress(handle, name);

        if (!paddr)
        {
                strcat (name, "A");
                paddr = (int) GetProcAddress(handle, name);
        }
        return paddr;
}


// -------------------- Floating Point Conversion --------------------

/*
ENTRY fconvert (double *addr, char *fmt, char *buf)
{
        return sscanf (buf, fmt, addr);
}


ENTRY fformat (double *addr, char *fmt, char *buf)
{
        return sprintf (buf, fmt, *addr);
}

void dummy (void)
{
        double fp;

        fp = 1.23e4;
        printf( "Dummy text to make 'C' include the floating point library %f", fp);
}
*/

ENTRY dummy (void)
{
    return 0;
}

ENTRY uppercase (LPTSTR string, DWORD length)
{
        return CharUpperBuff (string, length);
}

ENTRY lowercase (LPTSTR string, DWORD length)
{
        return CharLowerBuff (string, length);
}

// -------------------- Call Table --------------------

int (__stdcall *table[])() =
{
        Bye,                    // 0
        InitConsole,            // 1
        key,                    // 2
        Accept,                 // 3
        emit,                   // 4

        type,                   // 5
        cr,                     // 6
        cls,                    // 7
        keyq,                   // 8
        qcr,                    // 9

        Malloc,                 // 10
        Free,                   // 11
        open_file,              // 12
        close_file,             // 13
        read_line,              // 14

        save,                   // 15
        load_library,           // 16
        free_library,           // 17
        get_proc,               // 18
        gotoxy,                 // 19

        getxy,                  // 20
        dummy, // fconvert,     // 21
        dummy, // fformat,      // 22
        getcolrow,              // 23
        getstartup,             // 24
        tone,                   // 25
        beepstore,              // 26
        setfgbg,                // 27
        fpushkey,               // 28
        thescreen,              // 29
        charwh,                 // 30
        shiftmask,              // 31
        resize,                 // 32
        reposition,             // 33
        pointershape,           // 34
        cursorshape,            // 35
        getcursor,              // 36
        havemenu,               // 37
        condc,                  // 38
        printdlg,               // 39
        startprint,             // 40
        pageprint,              // 41
        endprint,               // 42
        initprint,              // 43
        closeprint,             // 44
        opendialog,             // 45
        savedialog,             // 46
        Realloc,                // 47
        hideconsole,            // 48
        showconsole,            // 49
        setfocus,               // 50
        wscroll,                // 51
        rowoffset,              // 52
        maxcolrow,              // 53
        setmaxcolrow,           // 54
        newdialog,              // 55
        normconsole,            // 56
        qualityprint,           // 57
        startapage,             // 58
        endapage,               // 59
        printcopies,            // 60
        printfrompages,         // 61
        printtopages,           // 62
        seek_file,              // 63
        make_file,              // 64
        read_file,              // 65
        SizeState,              // 66
        orientation,            // 67
        uppercase,              // 68
        lowercase,              // 69
        file_position,          // 70
        setcharwh,              // 71
        mark,                   // 72
        getfg,                  // 73
        getbg,                  // 74
        opendialog2,            // 75
        newdialog2,             // 76
        initprint2,             // 77
        printflags,             // 78
        getfilterindex,         // 79
};

// -------------------- Run Forth --------------------

void message (char *s)
{
        MessageBox (0, s, "Startup Error", MB_OK);
}

void parse (char *cmdline, char* dict)
{
        char buf[80], *s;

        strncpy(buf, cmdline, 79);
        s = strtok(buf, " ");

        if (s == NULL)
                strcpy (dict, StartupName);
        else
                strcpy (dict, s);
}
        
HKEY RegGetKey (void) 
{
    HKEY theKey;

    RegCreateKey (HKEY_CURRENT_USER, "SOFTWARE\\Win32For\\Settings", &theKey);
    return theKey;
}

void unload (void)
{
        char s[512];
        RECT rc;
        WINDOWPLACEMENT wp;
        BOOL result;
        HKEY theKey;
        int slen;

        ForthCleanup ();
        if (hwnd)
        {
            wp.length = sizeof(WINDOWPLACEMENT);
            if (!doingdll)
            {
                    // Only save position if I am not minimized
                    if (GetWindowPlacement(hwnd, &wp) && wp.showCmd != SW_SHOWMINIMIZED)
                    {
                            GetWindowRect(hwnd, &rc);
                            sprintf(s, "%d,%d,%d,%d\0", rc.left, rc.top, rc.right, rc.bottom);
                    for (slen = 1; s[slen] != '\0'; slen++);             // find length of the 's' buffer
                    theKey = RegGetKey ();
                    RegSetValueEx (theKey, "Console", 0, REG_SZ, s, slen+1); 
                    RegCloseKey (theKey);
                    }
            }
            DestroyWindow (hwnd);
                hwnd = 0;
        }
        if (screen)
            free (screen);
        result = VirtualFree (reservedaddress, reservedbytes, MEM_DECOMMIT);
        result = VirtualFree (reservedaddress, 0,  MEM_RELEASE);
}

void CleanUp (FILE *f)      // Close and release whatever is needed, prior to finishing the load
{
    if (f != NULL)
            fclose(f);
    else
    {
        UnlockResource (rGlobal);
        FreeResource (rHndl);
    }
}

int load (LPSTR cmd_line)           // returns the size of the image in bytes
{
        FILE *f;
        int   temp[HEADLENGTH];
        int n;
        LPVOID requestedaddress;
        LPVOID headrequested;
        char buf[MAX_SBUF];
        char *sbuf_end;
        LPSTR imagename;

    HMODULE myhandle;

        if (!doingdll)          // if not running as a DLL, then try to open .IMG file
    {
        strcpy (buf, cmd_line);
        strupr (buf);
        imagename = strstr (buf, "/IMAGE");
        if (imagename)          // allow commandline specification of image filename to load
        {                       // used in the form:  '/IMAGE imagename.img'
            imagename = imagename+6;
            imagename = strtok (imagename, " ");
            if (imagename)
                strcpy (sbuf, imagename);
        }
        else
        {
            myhandle = GetModuleHandle (NULL);
            GetModuleFileName (myhandle, sbuf, MAX_SBUF);
        }
        sbuf_end = strrchr (sbuf, '.');                // look for last occurance of a decimal point
        if  (sbuf_end)
            *sbuf_end = 0;                             // truncate name at decimal point
        strcat (sbuf, ".IMG\0");                       // then append the image extension
        f = fopen (sbuf, "rb");                        // open from program directory
    }
    else
    {
        f = NULL;           // force "f" to NULL if running as a DLL
    }
        if (f == NULL)          // if "f" is NULL, then read in the resource image
        {
        if (!(rHndl = FindResource (the_instance, "#1234", "IMAGE")))
        {
            message ("FindResource: Failed to find the Win32Forth resource or .IMG file");
            return (0);
        }
        if (!(rGlobal = LoadResource (the_instance,rHndl)))
        {
            FreeResource (rHndl);
            message ("LoadResource: Failed to load the Win32Forth resource or .IMG file"); 
            return (0);
        }
        resourceimageB = LockResource (rGlobal);
        actualsize = HEADLENGTH;                        // header length in Longs
        actualsize = actualsize * 4;                    // header length in Bytes
        MoveMemory (temp, resourceimageB, actualsize);  // move Bytes into temp buffer
        }
    else
        {
            fread (temp, sizeof(int), HEADLENGTH, f);   // read the first three cells from the image
    }

        if (temp[MAGICN] != MAGIC)                 // verify that the image is really ME!
        {
        CleanUp (f);
                message ("Bad dictionary image");
                return (0);
        }

        allocationsize     = temp[DSIZE];          // Forth dictionary size is at offset 2 long words
        actualsize         = temp[DACTUAL];
        headallocationsize = temp[HSIZE];          // Forth dictionary size is at offset 2 long words
        headactualsize     = temp[HACTUAL];
        headseparation     = temp[HSEPARATE];
        requestedaddress   = (LPVOID)temp[ORIG];   // the address where I would like to be located

        if (headallocationsize != 0)               // only allocate a bunch of room if we need it
        reservedbytes = headseparation+headallocationsize;
    else
        reservedbytes = allocationsize;

    reservedaddress = VirtualAlloc (requestedaddress, reservedbytes, MEM_RESERVE, PAGE_EXECUTE_READWRITE);
        if (reservedaddress == NULL)
        {
        CleanUp (f);
                wsprintf (buf, "Failed to reserve %d bytes of memory", reservedbytes);
                message (buf);
                return (0);
        }
    else
    {
        if ((reservedaddress != requestedaddress) && (requestedaddress != 0))
        {
            CleanUp (f);
                wsprintf (buf, "Requested address: %d was not a 64k boundry\nInstead, reserved: %d", 
                                requestedaddress, reservedaddress);
                message (buf);
                return (0);
        }
        }
        imageB = VirtualAlloc (reservedaddress, allocationsize, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
        if (imageB == NULL)
        {
        CleanUp (f);
                wsprintf (buf, "Failed to allocate %d bytes at address %d", allocationsize, reservedaddress);
                message (buf);
                return (0);
        }
    imageL = (int *)imageB;             // we have a byte pointe and a Long pointer

    if (f == NULL)
    {
        MoveMemory (imageB, resourceimageB, actualsize);
        n = actualsize;
        resourceimageB = resourceimageB+actualsize;
    }
    else
    {
        rewind (f);
        n = fread (imageB, 1, actualsize, f);
    }
        headrequested = imageB+headseparation;
// Allocate space for the headers which will be located 10 megabytes above the code/data area
        if (headallocationsize != 0)
        {
                himageB = VirtualAlloc (headrequested, headallocationsize, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
                if (himageB == NULL)
                {
                        CleanUp (f);
                        wsprintf (buf, "Failed to allocate %d bytes at address %d", headallocationsize, headrequested);
                        message (buf);
                        return (0);
                }
        if (headrequested != himageB)
        {
            CleanUp (f);
            wsprintf (buf, "HSystem Dictionary Allocation Failed!\n Requested addr: %x,\n     but Received: %x", headrequested, himageB);
            message (buf); 
                        return (0);
        }
        if (f == NULL)
        {
            MoveMemory (himageB, resourceimageB, headactualsize);
            n += headactualsize;
        }
        else
        {
                n += fread (headrequested, 1, headactualsize, f);
        }
        }
        CleanUp (f);
        return (n);
}

typedef int (*PFUNC)();

int run (int *imageL)
{
        PFUNC entry;
        if (imageL[ORIG]==0)
                entry=(PFUNC) ((int)imageL + imageL[CENTRY]);
        else
                entry=(PFUNC) imageL[CENTRY];
        return (*entry)();
}

int dodllrun (int *imageL)
{
        PFUNC dllentry;
        if (imageL[ORIG]==0)
                dllentry=(PFUNC) ((int)imageL + imageL[DLLINIT]);
        else
                dllentry=(PFUNC) imageL[DLLINIT];
        return (*dllentry)();
}

int DLLrun (void)       // Entry point used to initialize Forth when running as a DLL
{
        doingdll = TRUE;
        imagesize = load (NULL);
        if (imagesize == 0) return 0;
        imageL[TABLE]       = (int) table;
        imageL[HINST]       = (int) the_instance;
        imageL[CMDLEN]      = 0;
        imageL[CMDADR]      = 0;
        imageL[HCON]        = 0;               // old window NONE
        imageL[EXCEPT]      = 0;               // exception flag
        imageL[EXREC]       = 0;               // the exception context pointer
        imageL[WINMSGNTRY]  = 0;               // clear the window message handler
        imageL[MSGNTRY]     = 0;               // clear the key message handler
        dodllrun (imageL);
        return 0;
}

void DLLunrun (void)    // Entry point used to uninitialize Forth when running as a DLL
{
        unload ();
}

BOOL WINAPI DllMain (HINSTANCE hDLL, DWORD dwReason, LPVOID lpReserved)
{
  
        the_instance = hDLL ;

        switch (dwReason)
        {
            case DLL_PROCESS_ATTACH:
                DLLrun ();
                break;

            case DLL_PROCESS_DETACH:
                DLLunrun ();
                break;

        }

        return TRUE;
}

int PASCAL WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
{
        int r;
        EXCEPTION_POINTERS *the_info;
        long *the_rstack;

        the_instance = hInstance ;
        prev_instance = hPrevInstance;
        cmd_show = nCmdShow;
        cmd_line = lpszCmdParam;

        doingdll = FALSE;                       // we are a normal windows program

        imagesize = load (cmd_line);

        if (imagesize == 0) return 0;

        imageL[TABLE]  = (int) table;
        imageL[HINST]  = (int) the_instance;
        imageL[CMDLEN] = strlen (cmd_line);
        if (imageL[ORIG]==0)
                imageL[CMDADR] = (int) cmd_line - (int) imageL; // relative address
        else
    
        imageL[CMDADR] = (int) cmd_line;           // absolute address
        imageL[HCON]        = 0;                   // old window NONE
        imageL[EXCEPT]      = 0;                   // exception flag
        imageL[EXREC]       = 0;                   // the exception context pointer
        imageL[WINMSGNTRY]  = 0;                   // clear the window message handler
        imageL[MSGNTRY]     = 0;                   // clear the key message handler

//                      r = run (imageL);
        do 
        {
                __try
                {
                        r = run (imageL);
                }
                __except (      the_info = _exception_info(),
                                the_context = *the_info->ContextRecord,
                                the_exception = *the_info->ExceptionRecord,
                                the_rstack = (long *)the_context.Ebp,
                                imageL[EXRSTK] = the_context.Esi,
                                imageL[EXRSTK+1] = the_rstack[0],
                                imageL[EXRSTK+2] = the_rstack[1],
                                imageL[EXRSTK+3] = the_rstack[2],
                                EXCEPTION_EXECUTE_HANDLER)
                {
                        char buf[80];
                        int button;

                        imageL[EXCEPT] = _exception_code();
                        imageL[EXREC] = (int) &the_context;

                        wsprintf (buf, "Exception # %X", imageL[EXCEPT]);
                        button = MessageBox ((HWND)imageL[HCON], buf, "Exception", MB_OKCANCEL);
                        if (button == IDCANCEL)
                                Bye (1);
                }
        }
        while (1);

        Bye (r);
        return (0);
}

